*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\AUTOSIZE.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure LayoutAdjust()
*+               Procedure GetLayout()
*+               Function ISAPPXPTHEMED()
*+               Function GetZoomFactor()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#include "DLL.CH"

#xtranslate DllCall => HMG_CallDLL

#define Ctrl_Form       1
#define Ctrl_Name       2
#define Ctrl_Type       3
#define Ctrl_Row        4
#define Ctrl_Col        5
#define Ctrl_Width      6
#define Ctrl_Height     7
#define Ctrl_FontSize   8

#define RadioSpace      87

STATIC aControls := {}
STATIC nDivw     := 1
STATIC nDivh     := 1

MEMVAR _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Procedure LayoutAdjust()
*+
*+    Called from ( color.prg )   2 - procedure setup_color()
*+                                   1 - static procedure docolorinit()
*+                ( editdbf.prg )   2 - procedure edit_phpbb()
*+                                   2 - procedure edit_htmlsign()
*+                                   2 - procedure edit_user()
*+                                   1 - static procedure dophpinit()
*+                                   1 - static procedure dohtmlinit()
*+                                   1 - static procedure donotuserinit()
*+                ( forumhmg.prg )   2 - procedure main()
*+                                   1 - static procedure doinit()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE LayoutAdjust( cForm, nWidth, nHeight )

   //  AutoAdjust (c) 2007-2015 MigSoft / Danny / Pablo César
   // -------------------------------------------------------*
LOCAL hWnd       := GetFormHandle( cForm )
LOCAL hGrid, j, jMax, nPosi
LOCAL n_Row, n_Col, n_Width, n_Height, n_FontSize
LOCAL FormWidth  := GetProperty( cForm, "Width" )
LOCAL FormHeight := GetProperty( cForm, "Height" )
LOCAL i, ;                                                            // From no
           k, ;                                                       // Control no
           ParentForm, ;
           ControlCount, ;
           ControlName, ;
           ControlType, ;
           lvisible := .T.

   //    IF GetDesktopWidth() <= GetWindowWidth( hWnd )
   //       nWidth := GetDesktopWidth()
   //    ELSE
   //       nWidth := GetWindowWidth( hWnd )
   //    ENDIF
   //
   //    IF GetDesktopHeight() <= GetWindowHeight( hWnd )
   //       nHeight := GetDesktopHeight()
   //    ELSE
   //       nHeight := GetWindowHeight( hWnd )
   //    ENDIF

   IF IsWindowVisible( hWnd ) .AND. !IsAppXPThemed()
      HideWindow( hWnd )
   ELSE
      lvisible := .F.
   ENDIF

   i := ASCAN( _HMG_SYSDATA[ 67 ], hWnd )
   IF i > 0
      ParentForm := _HMG_SYSDATA[ 66 ] [ i ]

      IF cForm = "FORUM"
         nDivw := FormWidth / nWidth
         nDivh := FormHeight / nHeight
      ENDIF

      ControlCount := LEN( _HMG_SYSDATA[ 3 ] )

      // disable Update Window
      DllCall( "user32.dll", DLL_OSAPI, "LockWindowUpdate", hWnd )

      FOR k := 1 TO ControlCount
         ControlName := UPPER( _HMG_SYSDATA[ 2, k ] )

         IF _IsControlDefined( ControlName, ParentForm )
            ControlType := UPPER( ALLTRIM( _HMG_SYSDATA[ 1, k ] ) )

            nPosi := ASCAN( aControls, { | x | x[ Ctrl_Form ] = ParentForm .AND. x[ Ctrl_Name ] = ControlName } )
            IF nPosi > 0
               n_Row := aControls[ nPosi ] [ Ctrl_Row ]
               n_Col := aControls[ nPosi ] [ Ctrl_Col ]
               n_Width := aControls[ nPosi ] [ Ctrl_Width ]
               n_Height := aControls[ nPosi ] [ Ctrl_Height ]
               n_FontSize := aControls[ nPosi ] [ Ctrl_FontSize ]

               // RADIO use SPACEING
               IF ControlType = "RADIOGROUP"
                  _HMG_SYSDATA[ 22 ] [ k ] := ( RadioSpace ) * nDivw
               ENDIF

               IF ControlType = "STATUSBAR"
                  // do nothing
               ELSEIF ControlType = "TOOLBAR"
               ELSEIF ControlType = "TOOLBUTTON"
               ELSEIF ControlType = "TIMER"
               ELSEIF ControlType = "PROGRESSBAR"
                  _SetControlSizePos( ControlName, ParentForm, ;
                                      n_Row * nDivh, ;                // row
                                      n_Col * nDivw, ;                // column
                                      n_Width * nDivw, ;              // with
                                      n_Height * nDivh )              // height

               ELSEIF EMPTY( n_FontSize )
                  _SetFontSize( ControlName, ParentForm, 10 * nDivh )
                  msgdebug( ControlType + " " + ControlName + " not found !" )
               ELSE
                  _SetControlSizePos( ControlName, ParentForm, ;
                                      n_Row * nDivh, ;                // row
                                      n_Col * nDivw, ;                // column
                                      n_Width * nDivw, ;              // with
                                      n_Height * nDivh )              // height

                  IF n_FontSize > 0
                     _SetFontSize( ControlName, ParentForm, aControls[ nPosi ] [ Ctrl_FontSize ] * nDivh )
                  ELSE
                     // e.g. IMAGE
                  ENDIF
               ENDIF

               IF ControlType = "BROWSE" .OR. ControlType = "GRID"
                  hGrid := GetControlHandle( ControlName, ParentForm )
                  jMax := LEN( _HMG_SYSDATA[ 6, k ] )
                  FOR j = 1 TO jMax
                     //  autosize wide
                     LISTVIEW_SETCOLUMNWIDTH( hGrid, j - 1, - 1 )

                     // nWide := _HMG_SYSDATA[ 6, k, j ] * nDivw
                     // LISTVIEW_SETCOLUMNWIDTH( hGrid, j - 1, nWide )
                  NEXT j
               ENDIF
            ENDIF
         ENDIF
      NEXT k

      // enable Update Window
      DllCall( "user32.dll", DLL_OSAPI, "LockWindowUpdate", 0 )

      IF lvisible
         ShowWindow( hWnd )
      ENDIF
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure GetLayout()
*+
*+    Called from ( color.prg )   1 - static procedure docolorinit()
*+                ( editdbf.prg )   1 - static procedure dophpinit()
*+                                   1 - static procedure dohtmlinit()
*+                                   1 - static procedure donotuserinit()
*+                ( forumhmg.prg )   1 - static procedure doinit()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE GetLayout( cForm )

LOCAL hWnd  := GetFormHandle( cForm )
LOCAL n_Row, n_Col, n_Width, n_Height, n_FontSize, nPosi
LOCAL i, ;                                                            // From no
           k, ;                                                       // Control no
           ParentForm, ;
           ControlCount, ;
           ControlName, ;
           ControlType, ;
           nWidth, ;
           nHeight

   i := ASCAN( _HMG_SYSDATA[ 67 ], hWnd )
   IF i > 0
      ParentForm := UPPER( _HMG_SYSDATA[ 66 ] [ i ] )
      ControlCount := LEN( _HMG_SYSDATA[ 3 ] )

      FOR k := 1 TO ControlCount
         ControlName := UPPER( _HMG_SYSDATA[ 2, k ] )

         IF _IsControlDefined( ControlName, ParentForm )
            ControlType := UPPER( ALLTRIM( _HMG_SYSDATA[ 1, k ] ) )

            nPosi := ASCAN( aControls, { | x | x[ Ctrl_Form ] = ParentForm .AND. x[ Ctrl_Name ] = ControlName } )
            IF nPosi > 0
               // dupe Control
            ELSE
               n_Row := _GetControlRow( ControlName, ParentForm )
               n_Col := _GetControlCol( ControlName, ParentForm )
               n_Width := _GetControlWidth( ControlName, ParentForm )
               n_Height := _GetControlHeight( ControlName, ParentForm )
               n_FontSize := _GetFontSize( ControlName, ParentForm )

               AADD( aControls, { ParentForm, ControlName, ControlType, n_Row, n_Col, n_Width, n_Height, n_FontSize } )
            ENDIF
         ENDIF
      NEXT k
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Function ISAPPXPTHEMED()
*+
*+    Called from ( autosize.prg )   1 - procedure layoutadjust()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ISAPPXPTHEMED()

RETURN ( OS_ISWINXP_OR_LATER() ;                                      // <= hrb\contrib/hbwin/legacycv.c
         .AND. IsAppThemed() )                                        // <= HMG\h_window.prg

*+--------------------------------------------------------------------
*+
*+    Function GetZoomFactor()
*+
*+    Called from ( color.prg )   1 - static procedure docolorinit()
*+                ( editdbf.prg )   1 - static procedure dophpinit()
*+                                   1 - static procedure dohtmlinit()
*+                                   1 - static procedure donotuserinit()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetZoomFactor()

RETURN { nDivw, nDivh }

*+ EOF: AUTOSIZE.PRG
