*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\DLALLCOD.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure DownloadRenewCode()
*+               Static Procedure BreakDownload()
*+               Static Procedure NewFWcode()
*+               Static Procedure SayTimeInfo()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

STATIC lBreak   := .F.
STATIC lrunning := .F.

MEMVAR _HMG_SYSDATA
MEMVAR cWorkPath, cWorkURL, cWorkSign, cWorkPhpbb, aWorkPhpbb, lDebug
MEMVAR BGfont, FGfont

*+--------------------------------------------------------------------
*+
*+    Procedure DownloadRenewCode()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DownloadRenewCode()

LOCAL nStart, nEnd, cTitle, nPosi, cLastRec
LOCAL nCount := 0
LOCAL nMax
LOCAL nEvery

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
      RETURN
   ENDIF

   lBreak := .F.

   nPosi := ASCAN( aWorkPhpbb, { | e | e = cWorkPhpbb } )
   cTitle := aWorkPhpbb[ nPosi ]

   DEFINE WINDOW DlRenewCode ;
         AT 0, 0 ;
         WIDTH 324 ;
         HEIGHT 190 ;
         TITLE cTitle ;
         ICON "AUGEOHR" ;
         NOSIZE ;
         NOMAXIMIZE ;
         NOMINIMIZE ;
         TOPMOST ;
         ON INIT SnapToCtrl( "DlRenewCode", "Button_Go" ) ;
         BACKCOLOR BGfont

      DEFINE LABEL Label_INFO
         ROW 20
         COL 20
         WIDTH 270
         HEIGHT 46
         VALUE "press GO to start"
         TOOLTIP "can take much Time ..."
         FONTNAME "Arial"
         FONTSIZE 20
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VISIBLE .T.
      END LABEL

      DEFINE BUTTON Button_Go
         ROW 94
         COL 20
         WIDTH 270
         HEIGHT 46
         ACTION { || NewFWcode(), IF( IsWindowDefined( "DlRenewCode" ), DlRenewCode.Release, NIL ) }
         CAPTION "&Go"
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         PICTURE "MYGO"
         PICTALIGNMENT Right
      END BUTTON

      DEFINE BUTTON Button_Abort
         ROW 94
         COL 20
         WIDTH 270
         HEIGHT 46
         ACTION BreakDownload()
         CAPTION "&Abort"
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .F.
         PICTURE "MYSTOP"
         PICTALIGNMENT left
      END BUTTON

      DEFINE PROGRESSBAR ProgressBar_1
         ROW 144
         COL 4
         WIDTH 310
         HEIGHT 5
         RANGEMIN 1
         RANGEMAX 100
         VALUE 0
         VISIBLE .F.
         BACKCOLOR BGfont
         FORECOLOR FGfont
      END PROGRESSBAR

   END WINDOW

   DlRenewCode.Button_Go.setfocus

   ON KEY ESCAPE OF DlRenewCode ACTION IF( lrunning, BreakDownload(), IF( IsWindowDefined( "DlRenewCode" ), DlRenewCode.Release, NIL ) )
   ON KEY F1 OF DlRenewCode ACTION NIL

   CENTER WINDOW DlRenewCode IN FORUM
   ACTIVATE WINDOW DlRenewCode

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure BreakDownload()
*+
*+    Called from ( dlallcod.prg )   2 - procedure downloadrenewcode()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE BreakDownload()

   IF lrunning = .F.
      IF IsWindowDefined( "DlRenewCode" )
         DlRenewCode.Release
      ENDIF
   ELSE
      IF msgyesno( "Break Download ?", "Download" ) == .T.
         lrunning := .F.
         lBreak := .T.
      ENDIF
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure NewFWcode()
*+
*+    Called from ( dlallcod.prg )   1 - procedure downloadrenewcode()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE NewFWcode()

LOCAL aRecord    := {}
LOCAL aThread    := {}
LOCAL cText      := ""
LOCAL nTimeStart, nTimeStop, nTimeCalc
LOCAL ii, nThread
LOCAL nMax, nEvery

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
      RETURN
   ENDIF

   DoErrorLog( "CLEAR" )

   SetProperty( "DlRenewCode", "Button_Go", "Enabled", .F. )
   SetProperty( "DlRenewCode", "Button_Go", "VISIBLE", .F. )

   SetProperty( "DlRenewCode", "Button_Abort", "Enabled", .T. )
   SetProperty( "DlRenewCode", "Button_Abort", "VISIBLE", .T. )

   SetProperty( "DlRenewCode", "ProgressBar_1", "Value", 0 )
   SetProperty( "DlRenewCode", "ProgressBar_1", "VISIBLE", .T. )

   lrunning := .T.

   SetProperty( "FORUM", "RadioGroup_1", "value", 1 )
   SET FILTER TO

   ORDSETFOCUS( "DUPECHECK" )
   GO TOP
   DO WHILE !EOF()
      IF !EMPTY( TRIM( FORUM->CODE ) )
         AADD( aRecord, RECNO() )
      ENDIF
      SKIP
   ENDDO

   nMax := LEN( aRecord )
   nEvery := INT( nMax / 100 )
   SetProperty( "DlRenewCode", "ProgressBar_1", "Value", 0 )
   SetProperty( "DlRenewCode", "ProgressBar_1", "VISIBLE", .T. )

   nTimeStart := SECONDS()
   SetNewCursor( "WAIT" )
   SayBarText(, "ICOREDO" )

   FOR ii := 1 TO nMax
      IF lBreak = .T.
         EXIT
      ENDIF

      GOTO( aRecord[ ii ] )

      nThread := FORUM->TOPICNO
      IF ASCAN( aThread, { | x | x = nThread } ) > 0
      ELSE
         AADD( aThread, nThread )
         SayBarText( STRZERO( FORUM->TOPICNO, 5 ) + " " + FORUM->AUTHOR + " " + FORUM->TOPIC )

         DoReNewMsg( .F. )

         DO EVENTS
      ENDIF

      IF ( ( ii ) % ( nEvery ) ) == 0
         DO EVENTS
         SetProperty( "DlRenewCode", "ProgressBar_1", "Value", CalcPos( ii, nMax ) )
      ENDIF

      IF ( ( ii ) % ( 10 ) ) == 0
         DO EVENTS
         nTimeCalc := ( SECONDS() - nTimeStart ) / ii
         cText := "Time left : " + Sec2HMS( ( nMax - ii ) * nTimeCalc )
         SayTimeInfo( cText )
      ENDIF

   NEXT
   SetProperty( "DlRenewCode", "ProgressBar_1", "VISIBLE", .F. )

   SetProperty( "DlRenewCode", "Button_Abort", "Enabled", .F. )
   SetProperty( "DlRenewCode", "Button_Abort", "VISIBLE", .F. )

   nTimeStop := SECONDS()
   SayBarText( TIME() + " read " + LTRIM( STR( nMax ) ) + " Topic : " + SEC2HMS( nTimeStop - nTimeStart ), "ICONONE" )
   SetNewCursor()

   SayTimeInfo( "ready !" )
   lrunning := .F.

   DoErrorLog( "RESULT" )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure SayTimeInfo()
*+
*+    Called from ( dlallcod.prg )   2 - static procedure newfwcode()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SayTimeInfo( cInfo )

   DlRenewCode.Label_INFO.Value := cInfo
   DO EVENTS
RETURN

*+ EOF: DLALLCOD.PRG
