*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\DLFORUM.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Function StripHTMLCode()
*+               Function TextBetween()
*+               Static Function DoGetTime()
*+               Static Function DoGermanTime()
*+               Static Function StringDate()
*+               Static Procedure DoEndMsg()
*+               Procedure DoFillHTMLsign()
*+               Procedure onDummy()
*+               Procedure SayBarText()
*+               Static Function Only_A_Z()
*+               Function VAR2CHAR()
*+               Function Sec2HMS()
*+               Function HMS2Sec()
*+               Function MarkerPos()
*+               Function GetHTMLsign()
*+               Procedure StripCodeTag()
*+               Procedure EofBody()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "COMMON.CH"

//  #define USE_RTF

STATIC cLastTopic := ""
STATIC nMsgNo     := 1

MEMVAR cWorkPath, cWorkURL, aHTMLsign, aCODEsign, lDebug

*+--------------------------------------------------------------------
*+
*+    Function StripHTMLCode()
*+
*+    Called from ( dlrange.prg )   1 - static procedure startdownload()
*+                ( forumhmg.prg )   1 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
FUNCTION StripHTMLCode( cFile, nThreadNo, lReplace )

LOCAL cMemo     := MEMOREAD( cFile )
LOCAL nMemoLen  := LEN( cMemo )
LOCAL nStep     := 1
LOCAL nAllItems := 0
LOCAL nCount    := 1
LOCAL aAuthor   := {}
LOCAL aContent  := {}
LOCAL aGetCode  := {}
LOCAL aTopic    := {}
LOCAL aDateTime := {}
LOCAL aCodeIn   := {}
LOCAL aCodeOut  := {}
LOCAL aQouteIn  := {}
LOCAL aQouteOut := {}
LOCAL aEndBody  := {}
LOCAL aBody     := {}

LOCAL nPosi, nStart := 1
LOCAL nFrom, nTo, cAction, nMarker
LOCAL cRef, ii, cLine, cCode, cTopic, cBody, cAuthor, cBodyID
LOCAL dDate, cTime, cSeek, cDummy
LOCAL cTemp, nLen, cSave := ""

   DEFAULT lReplace TO .F.

   cRef := cWorkURL

   IF EMPTY( aHTMLsign )
      DoFillHTMLsign()
   ENDIF
   IF "The requested topic does not exist" $ cMemo
      RETURN 0
   ENDIF

   cMemo := STRTRAN( cMemo, CHR( 10 ), CRLF )

#ifdef USE_RTF
   NewRTFvalue( cMemo )
#endif

   aTopic := MarkerPos( '<h3 class="first">', cMemo )
   //   aAuthor := MarkerPos( '<p class="author">', cMemo )
   aAuthor := MarkerPos( 'class="author">', cMemo )

   IF "fivetechsupport" $ LOWER( cWorkURL ) .OR. "deskmodder" $ LOWER( cWorkURL )
      aDateTime := MarkerPos( '&raquo;', cMemo )
   ELSE
      aDateTime := MarkerPos( '<time datetime="', cMemo )
   ENDIF

   aContent := MarkerPos( '<div class="content">', cMemo )
   aQouteIn := MarkerPos( '<blockquote>', cMemo )
   aQouteOut := MarkerPos( '</blockquote>', cMemo )
   aCodeIn := MarkerPos( '<code>', cMemo )
   aCodeOut := MarkerPos( '</code>', cMemo )
   aEndBody := MarkerPos( '<div id=', cMemo )

   FOR ii := 1 TO LEN( aContent )
      AADD( aBody, { aContent[ ii ], "StartBody" } )
   NEXT
   FOR ii := 1 TO LEN( aQouteIn )
      AADD( aBody, { aQouteIn[ ii ], "QouteIn" } )
   NEXT
   FOR ii := 1 TO LEN( aQouteOut )
      AADD( aBody, { aQouteOut[ ii ], "QouteOut" } )
   NEXT
   FOR ii := 1 TO LEN( aCodeIn )
      AADD( aBody, { aCodeIn[ ii ], "aCodeIn" } )
   NEXT
   FOR ii := 1 TO LEN( aCodeOut )
      AADD( aBody, { aCodeOut[ ii ], "aCodeOut" } )
   NEXT
   FOR ii := 1 TO LEN( aEndBody )
      AADD( aBody, { aEndBody[ ii ], "EndeBody" } )
   NEXT

   aBody := ASORT( aBody,,, { | aX, aY | aX[ 1 ] < aY[ 1 ] } )

   IF EMPTY( aAuthor )
      RETURN 0
   ENDIF

   nMemoLen := LEN( cMemo )
   DO WHILE nStart < nMemoLen
      DO CASE
         CASE nStep = 1
            nPosi := HB_AT( "<title>", cMemo, nStart )
            IF nPosi > 0
               nFrom := nPosi + LEN( "<title>" )
               nStart := nFrom

               nPosi := HB_AT( "</title>", cMemo, nFrom )
               IF nPosi > 0
                  nTo := nPosi
                  nStart := nTo + LEN( "</title>" )
                  cTopic := SUBSTR( cMemo, nFrom, nTo - nFrom )

                  IF "fivetechsupport" $ LOWER( cWorkURL )
                     cTopic := STRTRAN( cTopic, "FiveTech Software tech support forums &bull; View topic - ", "" )
                  ELSEIF "hmgforum.com" $ LOWER( cWorkURL )
                     cTopic := STRTRAN( cTopic, " - HMGforum.com", "" )
                  ENDIF

                  cSave := cTopic
               ENDIF
            ENDIF
            ondummy( "1", cTopic )
            nStep := 2

         CASE nStep = 2
            nPosi := HB_AT( '<div class="pagination">', cMemo, nStart )
            IF nPosi > 0
               nFrom := nPosi + LEN( '<div class="pagination">' ) + 1
               nStart := nFrom

               nPosi := HB_AT( "</div>", cMemo, nFrom )
               IF nPosi > 0
                  nTo := nPosi
                  nStart := nTo + LEN( "</div>" )

                  nAllItems := VAL( SUBSTR( cMemo, nFrom, nTo - nFrom ) )
               ENDIF
            ENDIF
            ondummy( "2", nAllItems )
            nStep := 3

         CASE nStep = 3
            IF LEN( aTopic ) >= nCount
               nStart := aTopic[ nCount ]

               nPosi := HB_AT( '<h3 class="first">', cMemo, nStart )
               IF nPosi > 0
                  nFrom := nPosi
                  nStart := nFrom + LEN( '<h3 class="first">' ) + 1

                  nPosi := HB_AT( '</h3>', cMemo, nFrom )
                  IF nPosi > 0
                     nTo := nPosi + LEN( '</h3>' )
                     nStart := nTo

                     cTemp := SUBSTR( cMemo, nFrom, nTo - nFrom )
                     cTemp := TextBetween( cTemp, '<h3 class="first">', "</h3>" )
                     cTemp := TextBetween( cTemp, ">", "</a>" )

                     IF EMPTY( cTemp )
                        cTopic := "Re: " + cSave
                     ELSE
                        // new 12.09.2022
                        IF "<a href=" $ cTemp
                           cTemp := TextBetween( cTemp, "<a", ">" )
                           cTopic := STRTRAN( cTopic, cTemp, "" )
                           cTopic := STRTRAN( cTopic, "<a", "" )
                           cTopic := ALLTRIM( STRTRAN( cTopic, ">", "" ) )
                        ELSE
                           cTopic := cTemp
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
            ELSE
               cTopic := "Re: " + cSave
            ENDIF

            StripCodeTag( @cTopic )

            ondummy( "3", cTopic )
            nStep := 4
            nStart := 1

         CASE nStep = 4
            nStart := aAuthor[ nCount ]

            // nPosi := HB_AT( '<p class="author">', cMemo, nStart )
            nPosi := HB_AT( 'class="author">', cMemo, nStart )
            IF nPosi > 0
               // nFrom := nPosi + LEN( '<p class="author">' )
               nFrom := nPosi + LEN( 'class="author">' )
               nStart := nFrom
               // hm ... need for "Signature" ...
               cBodyID := SUBSTR( cMemo, nFrom + LEN( '<a href="./viewtopic.php?p=' ), 10 )

               nPosi := HB_AT( '</p>', cMemo, nFrom )
               IF nPosi > 0
                  nTo := nPosi
                  cLine := SUBSTR( cMemo, nFrom, nTo - nFrom )

                  cTemp := TextBetween( cLine, '<strong>', "</strong>" )
                  nLen := LEN( cTemp )
                  cAuthor := TextBetween( cTemp, ">", "</a>" )

                  // Date / Time
                  IF LEN( aDateTime ) >= nCount
                     nFrom := aDateTime[ nCount ]
                     IF "fivetechsupport" $ LOWER( cWorkURL ) .OR. "deskmodder" $ LOWER( cWorkURL )
                        nTo := HB_AT( "</p>", cMemo, nFrom )
                     ELSE
                        nTo := HB_AT( "</time>", cMemo, nFrom )
                     ENDIF
                     cLine := SUBSTR( cMemo, nFrom, nTo - nFrom )

                     IF "fivetechsupport" $ LOWER( cWorkURL )
                        dDate := StringDate( cLine, @cTime )
                     ELSEIF "deskmodder" $ LOWER( cWorkURL )
                        dDate := DoGermanTime( cLine, @cTime )
                     ELSE
                        dDate := DoGetTime( cLine, @cTime )
                     ENDIF
                  ENDIF

                  nStart := nTo + LEN( '</p>' )
               ENDIF
               ondummy( "4a", cAuthor, dDate, cTime )
            ENDIF

            // Deskmodder
            IF EMPTY( cAuthor ) .AND. EMPTY( dDate )
               cTemp := ""
               cAuthor := ""
               nStart := aAuthor[ nCount ]

               IF '<p class="author"></p>' $ cMemo
                  nStep := 3
                  nCount ++
                  IF nCount > LEN( aAuthor )
                     EXIT
                  ENDIF
                  LOOP
               ENDIF

               nPosi := HB_AT( 'class="author">', cMemo, nStart )
               IF nPosi > 0
                  nFrom := nPosi
                  nStart := nFrom

                  nPosi := HB_AT( '&raquo;', cMemo, nFrom )
                  IF nPosi > 0
                     nTo := nPosi
                     cTemp := TextBetween( cMemo, 'class="author">', "</p>" )

                     IF '<span class="responsive-hide">' $ cTemp
                        cTemp := TextBetween( cTemp, '<span class="responsive-hide">', "</p>" )
                        cAuthor := TextBetween( cTemp, 'class="username">', "</a>" )

                        cLine := TextBetween( cTemp, "&raquo;", "</p>" )
                        cLine := LTRIM( STRTRAN( cLine, '</span>', "" ) )
                        dDate := DoGermanTime( cLine, @cTime )
                     ELSE
                        nPosi := HB_AT( 'class="username">', cTemp, 1 )
                        cDummy := 'class="username">'
                        nStart := nPosi

                        IF EMPTY( nPosi )
                           nPosi := HB_AT( 'class="username-coloured">', cTemp, 1 )
                           cDummy := 'class="username-coloured">'
                           nStart := nPosi
                        ENDIF

                        IF EMPTY( nPosi )
                           nStart := nFrom
                        ELSE
                           nPosi := HB_AT( '</span>', cTemp, nPosi )
                           IF nPosi > 0
                              cTemp := STRTRAN( cTemp, '</span>', "" )
                              cAuthor := TextBetween( cTemp, cDummy, "</a>" )
                           ELSE
                              cAuthor := TextBetween( cTemp, cDummy, "</" )
                           ENDIF
                        ENDIF
                     ENDIF
                  ENDIF

                  IF EMPTY( cAuthor )
                     nPosi := HB_AT( '</a>', cTemp, nStart )
                     IF nPosi > 0
                        nTo := nPosi + LEN( '</a>' )
                        cTemp := SUBSTR( cMemo, nFrom, nTo - nFrom )
                        cAuthor := TextBetween( cTemp, cDummy, "</a>" )
                     ENDIF
                  ENDIF

                  // Date / Time
                  IF LEN( aDateTime ) >= nCount .AND. EMPTY( dDate )
                     nFrom := aDateTime[ nCount ]

                     IF "deskmodder" $ LOWER( cWorkURL )
                        nTo := HB_AT( "</p>", cMemo, nFrom )
                        cLine := SUBSTR( cMemo, nFrom, nTo - nFrom )

                        dDate := DoGermanTime( cLine, @cTime )
                     ENDIF
                  ENDIF

                  nStart := nTo + LEN( '</p>' )
               ENDIF
               ondummy( "4b", cAuthor, dDate, cTime )
            ENDIF

            IF lReplace = .T.
               nStep := 5
            ELSE
               // DUPE Check
               cSeek := STRZERO( nThreadNo, 5 ) + DTOS( dDATE ) + cTime
               SEEK( cSeek )
               IF FOUND()
                  cAuthor := ""
                  cTopic := ""
                  cBody := ""
                  cCode := ""
                  dDate := CTOD( "  .  .  " )                         // SET DATE GERMAN
                  cTime := "00:00:00"
                  aGetCode := {}
                  cBodyID := ""

                  nStep := 3
                  nCount ++
                  IF nCount > LEN( aAuthor )
                     EXIT
                  ENDIF
               ELSE
                  nStep := 5
               ENDIF
            ENDIF

         CASE nStep = 5
            nStart := aContent[ nCount ]

            nPosi := ASCAN( aBody, { | e | e[ 1 ] = nStart } )
            nStart := aBody[ nPosi ] [ 1 ]

            cBody := ""
            cCode := ""                                               // NOT "in" Body
            aGetCode := {}

            ii := 1
            DO WHILE .T.
               IF LEN( aBody ) < nPosi + ii
                  EXIT
               ENDIF

               // next Marker
               nMarker := aBody[ nPosi + ii ] [ 1 ]
               cAction := aBody[ nPosi + ii - 1 ] [ 2 ]

               cTemp := SUBSTR( cMemo, nStart, nMarker - nStart )

               // next Startpoint
               nStart := nMarker

               DO CASE
                  CASE cAction = "StartBody"
                     cBody := cTemp

                  CASE cAction = "EndeBody"
                     cBody += CRLF + cTemp
                     EXIT

                  CASE cAction = "QouteIn"
                     cBody += CRLF + cTemp

                  CASE cAction = "QouteOut"
                     cBody += CRLF + cTemp

                  CASE cAction = "aCodeIn"
                     cCode += cTemp
                     cBody += CRLF + cTemp

                  CASE cAction = "aCodeOut"
                     cCode += cTemp
                     cBody += CRLF + cTemp                            // add 21.09.2022

                     cCode := TextBetween( cCode, "<code>", "</code>" )

                     cBody := STRTRAN( cBody, cCode, "" )             // add 21.09.2022

                     cLine := ALLTRIM( MEMOLINE( cCode, 90, 1 ) )
                     IF "<div class=" $ cLine
                        cCODE := ALLTRIM( STRTRAN( cCODE, cLine, "" ) )
                     ENDIF

                     //  change HTML in CODE
                     StripCodeTag( @cCode )

                     AADD( aGetCode, ALLTRIM( cCODE ) )
                     cCode := ""
               ENDCASE
               ii ++
            ENDDO

            nStep := 3
            nCount ++

            EofBody( @cBody )

            FOR ii := 1 TO LEN( aHTMLsign )
               cBody := STRTRAN( cBody, TRIM( aHTMLsign[ ii ] [ 1 ] ), TRIM( aHTMLsign[ ii ] [ 2 ] ) )
            NEXT

            cBody := ALLTRIM( cBody )

            ondummy( "5", cBody )
#ifdef USE_RTF
            msgdebug( nCount, cAuthor, cTopic, dDate, cTime, cBody, cCode )
#else
            DoEndMsg( cRef, nThreadNo, cAuthor, cBody, dDATE, cTopic, aGetCode, cTime, lReplace )
#endif

            cAuthor := ""
            cTopic := ""
            cBody := ""
            cCode := ""
            dDate := CTOD( "  .  .  " )                               // SET DATE GERMAN
            cTime := "00:00:00"
            aGetCode := {}
            cBodyID := ""

            IF nCount > LEN( aAuthor )
               EXIT
            ENDIF

      ENDCASE
   ENDDO

RETURN nAllItems

*+--------------------------------------------------------------------
*+
*+    Function TextBetween()
*+
*+    Called from ( dlforum.prg )  13 - function striphtmlcode()
*+                                   1 - static function dogettime()
*+
*+--------------------------------------------------------------------
*+
FUNCTION TextBetween( cText, cStartTag, cCloseTag, nPos, cLeft, cRight )

LOCAL cRet   := ""
LOCAL nStart, nEnd, nLen

   DEFAULT nPos TO 1

   IF !( cStartTag $ cText )
      cLeft := cText
      cRight := ""
      RETURN ""
   ENDIF

   cRight := AfterAtNum( cStartTag, cText, nPos )
   cRet := BeforAtNum( cCloseTag, cRight, 1 )

   IF PCOUNT() > 4
      cLeft := BeforAtNum( cStartTag, cText, nPos )
      cRight := AfterAtNum( cCloseTag, cRight, 1 )
   ENDIF

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Static Function DoGetTime()
*+
*+    Called from ( dlforum.prg )   1 - function striphtmlcode()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION DoGetTime( cLine, cTime )

LOCAL dDate := CTOD( "  .  .  " )                                     // SET DATE GERMAN
LOCAL cDate := ""
LOCAL nPos  := 0
LOCAL cRet  := ""
LOCAL YY, MM, DD

   cDate := TextBetween( cLine, 'datetime="', '">' )

   YY := SUBSTR( cDate, 1, 4 )
   MM := SUBSTR( cDate, 6, 2 )
   DD := SUBSTR( cDate, 9, 2 )
   dDate := STOD( YY + MM + DD )

   cTime := LTRIM( SUBSTR( cDate, 12, 8 ) )

RETURN dDate

*+--------------------------------------------------------------------
*+
*+    Static Function DoGermanTime()
*+
*+    Called from ( dlforum.prg )   3 - function striphtmlcode()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION DoGermanTime( cLine, cTime )

LOCAL dDate := CTOD( "  .  .  " )                                     // SET DATE GERMAN
LOCAL cDate := ""
LOCAL nPos  := 0
LOCAL cRet  := ""
LOCAL YY, MM, DD, nSec

   cDate := STRTRAN( cLine, "&raquo;", "" )
   cDate := LTRIM( STRTRAN( cDate, "</span>", "" ) )

   DD := SUBSTR( cDate, 1, 2 )
   MM := SUBSTR( cDate, 4, 2 )
   YY := SUBSTR( cDate, 7, 4 )
   dDate := STOD( YY + MM + DD )

   ondummy( TIME(), PROCNAME( 1 ), PROCLINE( 1 ), cDate, cLine )

   cTime := LTRIM( SUBSTR( cDate, 12, 8 ) )
   nSec := HMS2Sec( cTime )
   cTime := Sec2HMS( nSec )

RETURN dDate

*+--------------------------------------------------------------------
*+
*+    Static Function StringDate()
*+
*+    Called from ( dlforum.prg )   1 - function striphtmlcode()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION StringDate( cLine, cTime )

LOCAL ii, nPosi, cMonth, cNext, cYear, nSec, cMore
LOCAL cYYYY, cMM, cDD, cHHMMSS
LOCAL aMonth := { "Jan", ;
                     "Feb", ;
                     "Mar", ;
                     "Apr", ;
                     "May", ;
                     "Jun", ;
                     "Jul", ;
                     "Aug", ;
                     "Sep", ;
                     "Oct", ;
                     "Nov", ;
                     "Dec" }

   cTime := "00:00:00"

   FOR ii := 1 TO LEN( aMonth )
      IF aMonth[ ii ] $ cLine
         cMM := STRZERO( ii, 2 )
         cMonth := aMonth[ ii ]
         EXIT
      ENDIF
   NEXT
   IF EMPTY( cMM )
      RETURN CTOD( " . . " )
   ENDIF

   nPosi := AT( "&raquo;", cLine )
   IF nPosi > 0
      cLine := SUBSTR( cLine, nPosi + 7 )
   ELSE
      RETURN CTOD( " . . " )
   ENDIF

   // &raquo; Thu Oct 06, 2005 6:24 pm </p>
   nPosi := AT( cMonth, cLine )
   IF nPosi > 0
      cNext := ALLTRIM( SUBSTR( cLine, nPosi + 3 ) )

      nPosi := AT( ",", cNext )
      IF nPosi > 0
         cDD := LTRIM( SUBSTR( cNext, 1, nPosi - 1 ) )

         cYear := LTRIM( SUBSTR( cNext, nPosi + 1 ) )
         cYYYY := SUBSTR( cYear, 1, 4 )

         cMore := ALLTRIM( SUBSTR( cYear, 5 ) )
         IF "pm" $ cMore
            nPosi := AT( "pm", cMore )
            cHHMMSS := SUBSTR( cMore, 1, nPosi - 1 )
            nSec := HMS2SEC( cHHMMSS )
            nSec += ( 12 * 60 * 60 )
            cHHMMSS := SEC2HMS( nSec )
         ELSE
            nPosi := AT( "am", cMore )
            cHHMMSS := SUBSTR( cMore, 1, nPosi - 1 )
            nSec := HMS2SEC( cHHMMSS )
            cHHMMSS := SEC2HMS( nSec )
         ENDIF

      ELSE
         RETURN CTOD( " . . " )
      ENDIF
   ELSE
      RETURN CTOD( " . . " )
   ENDIF

   cTime := cHHMMSS

RETURN STOD( cYYYY + cMM + cDD )

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoEndMsg()
*+
*+    Called from ( dlforum.prg )   1 - function striphtmlcode()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoEndMsg( cRef, nThreadNo, cAuthor, cBody, dDATE, cTopic, aGetCode, cTime, lReplace )

LOCAL n, nLen, cSeek, ii, cCode := "", nPosi, nStart := 1
LOCAL aPosi   := {}
LOCAL nRecord

   nLen := LEN( aGetCode )
   FOR n := 1 TO nLen
      cCode += aGetCode[ n ] + CRLF
      cCode += CRLF
      cCode += REPLICATE( "*", 80 )
      cCode += CRLF
   NEXT

   IF EMPTY( dDATE )
      dDATE := CTOD( "  .  .  " )
   ENDIF

   IF EMPTY( cTime )
      cTime := "00:00:00"
   ENDIF

   cSeek := STRZERO( nThreadNo, 5 ) + DTOS( dDATE ) + cTime
   SEEK( cSeek )
   IF FOUND()
      ondummy( TIME(), "found", cSeek, lReplace )
      IF lReplace = .T.
         nRecord := RECNO()
         IF Net_Lock( nRecord )
            REPLACE FORUM->TOPIC WITH cTopic
            REPLACE FORUM->CODE WITH TRIM( cCode )
            REPLACE FORUM->BODY WITH TRIM( cBody )
            DBRUNLOCK( nRecord )
            SKIP( 0 )
         ENDIF
         ondummy( TIME(), nThreadNo, nMsgNo, cBody, cCode )
      ENDIF
   ELSE
      IF SUBSTR( cTopic, 1, 3 ) = "Re:" .OR. ( "- Page" $ cTopic )
         nMsgNo ++
      ELSE
         nMsgNo := 1
      ENDIF

      IF Net_Append()
         REPLACE FORUM->AUTHOR WITH cAuthor
         REPLACE FORUM->TOPIC WITH cTopic
         REPLACE FORUM->TOPICNO WITH nThreadNo
         REPLACE FORUM->NOOFMSG WITH nMsgNo
         REPLACE FORUM->LINK WITH cRef + "?t=" + LTRIM( STR( nThreadNo ) )
         REPLACE FORUM->TTIME WITH cTime
         REPLACE FORUM->CODE WITH TRIM( cCode )
         REPLACE FORUM->BODY WITH TRIM( cBody )

         IF !EMPTY( dDATE )
            IF VALTYPE( dDATE ) = "D"
               REPLACE FORUM->TDATE WITH dDATE
            ENDIF
         ENDIF

         IF '<dl class="file">' $ cBody
            aPosi := MarkerPos( '<dl class="file">', cBody )
            FOR ii := 1 TO LEN( aPosi )
               nStart := aPosi[ ii ]
               nPosi := HB_AT( '<dt class="attach-image">', cBody, nStart )
               IF nPosi > 0
                  REPLACE FORUM->INFO1 WITH "Have Image"
                  LOOP
               ENDIF

               nPosi := HB_AT( '<dt><span class="', cBody, nStart )
               IF nPosi > 0
                  REPLACE FORUM->INFO2 WITH "Have Attachment"
               ENDIF
            NEXT
         ENDIF

         SKIP( 0 )

         IF cLastTopic <> ALLTRIM( cTopic ) .AND. .NOT. ( "- Page" $ cTopic )
            cLastTopic := ALLTRIM( cTopic )

            SayBarText( cAuthor + " " + cTopic )
            nMsgNo := 1
         ENDIF
      ENDIF
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure DoFillHTMLsign()
*+
*+    Called from ( dlforum.prg )   1 - function striphtmlcode()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoFillHTMLsign()

LOCAL cHome := hb_DirBase()

   aHTMLsign := {}

   SELECT 3
   // USE (cHome+"HTMLSIGN.DBF") VIA "DBFCDX"
   IF Net_Use( cHome + "HTMLSIGN.DBF", .F. )
      DO WHILE !EOF()
         AADD( aHTMLsign, { FIELD->HTMLSIGN, FIELD->CHANGETO } )
         SKIP
      ENDDO
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", cHome + "HTMLSIGN.DBF" )
   ENDIF

   SELECT 1
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure onDummy()
*+
*+    Called from ( dlforum.prg )   6 - function striphtmlcode()
*+                                   1 - static function dogermantime()
*+                                   2 - static procedure doendmsg()
*+                ( dlrange.prg )   3 - static procedure startdownload()
*+                                   2 - function downloadfromwww()
*+                ( forumhmg.prg )   2 - procedure main()
*+                                   1 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE onDummy()

LOCAL iMax   := PCOUNT()
LOCAL i
LOCAL cText  := ""
LOCAL xValue

   IF lDebug = .T.
      FOR i := 1 TO iMax - 1
         cText += Var2Char( PValue( i ) ) + CHR( 9 )
      NEXT
      cText += Var2Char( PValue( iMax ) )

      IF EMPTY( cText )
         cText := TIME() + " no Parameter ? " + CRLF + PROCNAME( 1 ) + STR( PROCLINE( 1 ) ) + CRLF + PROCNAME( 2 ) + STR( PROCLINE( 2 ) )
      ENDIF
      SET CONSOLE OFF
      SET ALTER ON

      // ? cText
      QOUT( cText )

      SET ALTER OFF
      SET CONSOLE ON
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SayBarText()
*+
*+    Called from ( dlallcod.prg )   1 - procedure downloadrenewcode()
*+                                   4 - static procedure newfwcode()
*+                ( dlforum.prg )   1 - static procedure doendmsg()
*+                ( dlrange.prg )   2 - procedure downloadrange()
*+                                   2 - static procedure startdownload()
*+                                   1 - function downloadfromwww()
*+                ( forumhmg.prg )   1 - procedure main()
*+                                   2 - static procedure docleanbody()
*+                                   1 - static procedure dochangeforum()
*+                                   3 - procedure dorenewmsg()
*+                ( translat.prg )   1 - procedure translatememoform()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SayBarText( cText, cAction )

LOCAL bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
LOCAL nHWnd     := GetControlHandle( "StatusBar", "FORUM" )

   DEFAULT cText TO ""
   DEFAULT cAction TO "TEXT"

   BEGIN SEQUENCE
      DO CASE
         CASE cAction = "ICOERROR"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICOERROR" )
         CASE cAction = "ICONONE"
            _SetStatusIcon( "StatusBar", "FORUM", 2, nil )
         CASE cAction = "ICORELOAD"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICORELOAD" )
         CASE cAction = "ICOCLEAN"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICOCLEAN" )
         CASE cAction = "ICOREDO"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICOREDO" )
         CASE cAction = "ICOGO"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICOGO" )
         CASE cAction = "ICOSTOP"
            _SetStatusIcon( "StatusBar", "FORUM", 2, "ICOSTOP" )
      ENDCASE

      // cText := Only_A_Z( cText )
      SetProperty( "FORUM", "StatusBar", "Item", 1, cText )
   END SEQUENCE
   ERRORBLOCK( bOldError )

   DO EVENTS
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function Only_A_Z()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Only_A_Z( cIn )                                       // unused

LOCAL cOut := ""
LOCAL cOk, cSign, ii, iMax := LEN( cIn )

   cOk := "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
   cOk += "abcdefghijklmnopqrstuvwxyz"
   cOk += "1234567890 _+-*,.;:!$%&/()=?`'><#"

   FOR ii := 1 TO iMax
      cSign := SUBSTR( cIn, ii, 1 )
      IF cSign $ cOk
         cOut += cSign
      ENDIF
   NEXT

RETURN cOut

*+--------------------------------------------------------------------
*+
*+    Function VAR2CHAR()
*+
*+    Called from ( dlforum.prg )   2 - procedure ondummy()
*+                ( dlrange.prg )   4 - function downloadfromwww()
*+
*+--------------------------------------------------------------------
*+
FUNCTION VAR2CHAR( cIn )

LOCAL cOut := hb_valToExp( cIn )
RETURN STRTRAN( cOut, '"', '' )

*+--------------------------------------------------------------------
*+
*+    Function Sec2HMS()
*+
*+    Called from ( dlallcod.prg )   2 - static procedure newfwcode()
*+                ( dlforum.prg )   1 - static function dogermantime()
*+                                   2 - static function stringdate()
*+                ( dlrange.prg )   3 - static procedure startdownload()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Sec2HMS( nSec )

LOCAL cHHMMSS := ""
LOCAL nInt    := 0
LOCAL nHH     := 0
LOCAL nMM     := 0
LOCAL nSS     := 0

   IF nSec >= 3600
      nHH := INT( nSec / 60 / 60 )
      nInt := ( nSec - ( nHH * 60 * 60 ) ) / 60
   ELSE
      nInt := nSec / 60
   ENDIF

   nMM := INT( nInt )
   nSS := INT( ( nInt - nMM ) * 60 )

   cHHMMSS := IF( nHH > 0, STRZERO( nHH, 2 ) + ":", "00:" ) + ;
                  IF( nMM > 0, STRZERO( nMM, 2 ) + ":", "00:" ) + ;
                  STRZERO( nSS, 2 )
RETURN cHHMMSS

*+--------------------------------------------------------------------
*+
*+    Function HMS2Sec()
*+
*+    Called from ( dlforum.prg )   1 - static function dogermantime()
*+                                   2 - static function stringdate()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMS2Sec( cHHMMSS )

LOCAL nSec := 0
LOCAL nHH  := 0
LOCAL nMM  := 0
LOCAL nSS  := 0

   nHH := VAL( SUBSTR( cHHMMSS, 1, 2 ) ) * 60 * 60
   nMM := VAL( SUBSTR( cHHMMSS, 4, 5 ) ) * 60
   nSS := VAL( SUBSTR( cHHMMSS, 7, 8 ) )

   nSec = nHH + nMM + nSS

RETURN nSec

*+--------------------------------------------------------------------
*+
*+    Function MarkerPos()
*+
*+    Called from ( dlforum.prg )  10 - function striphtmlcode()
*+                                   1 - static procedure doendmsg()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+
*+--------------------------------------------------------------------
*+
FUNCTION MarkerPos( cMarker, cText )

LOCAL aMarkPos := {}
LOCAL nStart   := 1
LOCAL nPosi    := 1

   DO WHILE nPosi > 0
      nPosi := HB_AT( cMarker, cText, nStart )
      IF nPosi > 0
         AADD( aMarkPos, nPosi )
         nStart := nPosi + LEN( cMarker ) + 1
      ENDIF
   ENDDO
RETURN aMarkPos

*+--------------------------------------------------------------------
*+
*+    Function GetHTMLsign()
*+
*+    Called from ( forumhmg.prg )   1 - static procedure createstriphtml()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetHTMLsign()

LOCAL aHTMLsign := {}
   AADD( aHTMLsign, { "<a href=", "" } )
   AADD( aHTMLsign, { 'class="postlink">', "" } )
   AADD( aHTMLsign, { "</a>", "" } )
   AADD( aHTMLsign, { "<br>", "" } )
   AADD( aHTMLsign, { "\r\n", "CHR(13)+CHR(10)" } )
   AADD( aHTMLsign, { "<div class=\content\>", "" } )
   AADD( aHTMLsign, { '<span style="text-decoration:underline">', "" } )
   AADD( aHTMLsign, { "<span style=\text-decoration:underline\>", "" } )
   AADD( aHTMLsign, { "</span>", "" } )

   AADD( aHTMLsign, { '<strong class="text-strong">', "" } )
   AADD( aHTMLsign, { "<strong class=\text-strong\>", "" } )
   AADD( aHTMLsign, { "</strong>", "" } )
   AADD( aHTMLsign, { '<cite>', "" } )
   AADD( aHTMLsign, { '</cite>', "" } )
   AADD( aHTMLsign, { '<div>', "" } )
   AADD( aHTMLsign, { '</div>', "" } )
   AADD( aHTMLsign, { '&lt;', "" } )                                  // "<" )
   AADD( aHTMLsign, { '&gt;', "" } )                                  // ">" )

   AADD( aHTMLsign, { 'width="15"', "" } )
   AADD( aHTMLsign, { 'height="17"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_e_wink.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_e_smile.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_question.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_e_biggrin.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_e_sad.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_eek.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_mrgreen.gif"', "" } )
   // for all ./images/smilies/
   AADD( aHTMLsign, { '<img class="smilies" src="', "" } )

   AADD( aHTMLsign, { 'class="postimage"', "" } )
   AADD( aHTMLsign, { 'alt="Image">', "" } )

   AADD( aHTMLsign, { 'alt=";)"', ";)" } )
   AADD( aHTMLsign, { 'alt=":mrgreen:"', ":mrgreen:" } )
   AADD( aHTMLsign, { 'alt=":)" ', ":)" } )
   AADD( aHTMLsign, { 'alt=":?:"', ":?:" } )                          // RTF ?
   AADD( aHTMLsign, { 'alt=":D"', ":D" } )
   AADD( aHTMLsign, { 'alt=":("', ":(" } )
   AADD( aHTMLsign, { 'alt=":shock:"', ":shock:" } )

   AADD( aHTMLsign, { 'title="Wink>"', "" } )
   AADD( aHTMLsign, { 'title="Mr. Green">', "" } )
   AADD( aHTMLsign, { 'title="Smile">', "" } )
   AADD( aHTMLsign, { 'title="Question">', "" } )
   AADD( aHTMLsign, { 'title="Very Happy">', "" } )
   AADD( aHTMLsign, { 'title="Sad">', "" } )
   AADD( aHTMLsign, { 'title="Shocked">', "" } )

   // Fivewin
   //
   AADD( aHTMLsign, { "<br />", CHR( 13 ) + CHR( 10 ) } )
   //    AADD( aHTMLsign, { "<br /><br />", CHR( 13 ) + CHR( 10 ) } )
   //    AADD( aHTMLsign, { "<br />", " " } )
   AADD( aHTMLsign, { "< />", "" } )
   AADD( aHTMLsign, { " />", "" } )

   AADD( aHTMLsign, { '&#123;', "{" } )                               // + CRLF )
   AADD( aHTMLsign, { '&#125;', "}" } )                               // + CRLF )

   AADD( aHTMLsign, { './images/smilies/icon_wink.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_smile.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_question.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_biggrin.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_sad.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_eek.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_mrgreen.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_lol.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_mad.gif"', "" } )
   AADD( aHTMLsign, { './images/smilies/icon_question.gif"', "" } )

   // for all ./images/smilies/
   AADD( aHTMLsign, { '<img src="', "" } )

   AADD( aHTMLsign, { 'title="Wink"', "" } )
   AADD( aHTMLsign, { 'title="Smile"', "" } )
   AADD( aHTMLsign, { 'title="Question"', "" } )
   AADD( aHTMLsign, { 'title="Very Happy"', "" } )
   AADD( aHTMLsign, { 'title="Sad"', "" } )
   AADD( aHTMLsign, { 'title="Shocked"', "" } )
   AADD( aHTMLsign, { 'title="Mr. Green"', "" } )
   AADD( aHTMLsign, { 'title="Laughing"', "" } )

   AADD( aHTMLsign, { 'alt=":lol:"', ":lol:" } )
   AADD( aHTMLsign, { 'alt=":x"', ":x" } )

   AADD( aHTMLsign, { '<!-- w -->', "" } )
   AADD( aHTMLsign, { '<!-- m -->', "" } )
   AADD( aHTMLsign, { '<!-- e -->', "" } )
   AADD( aHTMLsign, { '<a class="postlink" href=', "" } )

   AADD( aHTMLsign, { '<dl class="codebox">', "" } )
   AADD( aHTMLsign, { "<code>", "" } )
   AADD( aHTMLsign, { "</code>", "" } )
   AADD( aHTMLsign, { '<dt>Code:', "" } )
   AADD( aHTMLsign, { '"#"', "" } )
   AADD( aHTMLsign, { 'onclick="selectCode(this);', "" } )
   AADD( aHTMLsign, { 'return false;', "" } )
   AADD( aHTMLsign, { '">Select all', "" } )
   AADD( aHTMLsign, { 'onclick="expandCode(this);', "" } )
   AADD( aHTMLsign, { '">Expand view', "" } )
   AADD( aHTMLsign, { '</dt>', "" } )
   AADD( aHTMLsign, { '<dd>', "" } )
   AADD( aHTMLsign, { '</dd>', "" } )
   AADD( aHTMLsign, { '</dl>', "" } )

   //    AADD( aHTMLsign, { '[quote]' , "\i"  } )
   //    AADD( aHTMLsign, { '[/quote]', "\i0" } )
   //    AADD( aHTMLsign, { '<blockquote>'   , "\i"  } )
   //    AADD( aHTMLsign, { '</blockquote>'  , "\i0" } )

   AADD( aHTMLsign, { 'alt="Image"', "" } )
   AADD( aHTMLsign, { '<span style="font-weight: bold">', "" } )

   AADD( aHTMLsign, { '<div class="codebox">', "" } )
   AADD( aHTMLsign, { '<p>Code:   ">', "" } )
   AADD( aHTMLsign, { 'Alles auswhlen', "" } )
   AADD( aHTMLsign, { '</p>', "" } )
   AADD( aHTMLsign, { '<pre>', "" } )
   AADD( aHTMLsign, { '</pre>', "" } )

   AADD( aHTMLsign, { '<div class="content">', "" } )

   AADD( aHTMLsign, { '<span style="color:', "" } )
   AADD( aHTMLsign, { '#0000FF', "" } )
   AADD( aHTMLsign, { '#BF0040', "" } )
   AADD( aHTMLsign, { '#00C800', "" } )
   AADD( aHTMLsign, { '#000000', "" } )
   AADD( aHTMLsign, { '#B900B9', "" } )
   AADD( aHTMLsign, { '#ff0000', "" } )
   AADD( aHTMLsign, { '#0000ff', "" } )
   AADD( aHTMLsign, { '#00D7D7', "" } )

   AADD( aHTMLsign, { ';">', "" } )

   AADD( aHTMLsign, { '&#40;', "(" } )
   AADD( aHTMLsign, { '&#41;', ")" } )

   AADD( aHTMLsign, { '&#91;', "[" } )
   AADD( aHTMLsign, { '&#93;', "]" } )
   AADD( aHTMLsign, { '&amp;', "&" } )

   AADD( aHTMLsign, { "&nbsp;", " " } )
   AADD( aHTMLsign, { 'ÿ', " " } )
   AADD( aHTMLsign, { "&quot;", '"' } )

RETURN aHTMLsign

*+--------------------------------------------------------------------
*+
*+    Procedure StripCodeTag()
*+
*+    Called from ( dlforum.prg )   2 - function striphtmlcode()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE StripCodeTag( cCode )                                       // per Reference

   //  change HTML in CODE
   cCode := STRTRAN( cCode, "<br />", CRLF )
   cCode := STRTRAN( cCode, '&#123;', "{" )                           // + CRLF )
   cCode := STRTRAN( cCode, '&#125;', "}" )                           // + CRLF )
   cCode := STRTRAN( cCode, "&lt;", CHR( 34 ) )                       // "<" )
   cCode := STRTRAN( cCode, "&gt;", CHR( 34 ) )                       // ">" )
   cCode := STRTRAN( cCode, '&#40;', "(" )
   cCode := STRTRAN( cCode, '&#41;', ")" )
   cCode := STRTRAN( cCode, '&#91;', "[" )
   cCode := STRTRAN( cCode, '&#93;', "]" )
   cCode := STRTRAN( cCode, '&amp;', "&" )

   cCode := STRTRAN( cCode, "&nbsp;", " " )
   cCode := STRTRAN( cCode, 'ÿ', " " )
   cCode := STRTRAN( cCode, "&quot;", '"' )

   cCode := STRTRAN( cCode, '<span', "" )
   cCode := STRTRAN( cCode, '#0000FF', "" )
   cCode := STRTRAN( cCode, '#BF0040', "" )
   cCode := STRTRAN( cCode, '#00C800', "" )
   cCode := STRTRAN( cCode, '#000000', "" )
   cCode := STRTRAN( cCode, '#B900B9', "" )
   cCode := STRTRAN( cCode, '#ff0000', "" )
   cCode := STRTRAN( cCode, '#0000ff', "" )
   cCode := STRTRAN( cCode, '#00D7D7', "" )
   cCode := STRTRAN( cCode, ';">', "" )
   cCode := STRTRAN( cCode, '</span>', "" )
   cCode := STRTRAN( cCode, '</div>', "" )
   cCode := STRTRAN( cCode, 'style="color:', "" )

   cCode := STRTRAN( cCode, CHR( 194 ), " " )
   cCode := STRTRAN( cCode, CHR( 160 ), " " )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure EofBody()
*+
*+    Called from ( dlforum.prg )   1 - function striphtmlcode()
*+                ( forumhmg.prg )   1 - static procedure docleanbody()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE EofBody( cBody )                                            // per Reference

LOCAL nPosi
   nPosi := HB_AT( '<dl class="postprofile" id="', cBody, 1 )
   IF nPosi > 0
      cBody := TRIM( SUBSTR( cBody, 1, nPosi - 1 ) )
   ENDIF

   nPosi := HB_AT( '<div class="notice"', cBody, 1 )
   IF nPosi > 0
      cBody := TRIM( SUBSTR( cBody, 1, nPosi - 1 ) )
   ENDIF

   nPosi := HB_AT( "<div id='list_thanks", cBody, 1 )
   IF nPosi > 0
      cBody := TRIM( SUBSTR( cBody, 1, nPosi - 1 ) )
   ENDIF

   nPosi := HB_AT( '<div class="back2top">', cBody, 1 )
   IF nPosi > 0
      cBody := TRIM( SUBSTR( cBody, 1, nPosi - 1 ) )
   ENDIF

RETURN

*+ EOF: DLFORUM.PRG
