*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\DLRANGE.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure DownloadRange()
*+               Static Procedure BreakDownload()
*+               Static Procedure DoDownloadNow()
*+               Static Procedure IncrementProgressbar()
*+               Static Procedure SayInfo()
*+               Static Procedure StartDownLoad()
*+               Procedure SnapToCtrl()
*+               Function DownloadFromWWW()
*+               Procedure DoErrorLog()
*+               Function GetThreadFileName()
*+               Function YYMMDD()
*+               Procedure InputSID()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

#define MAX_PATH           256

STATIC lBreak    := .F.
STATIC lrunning  := .F.
STATIC lShowOnce := .T.
STATIC aError    := {}
STATIC cSID      := ""

MEMVAR _HMG_SYSDATA
MEMVAR cWorkPath, cWorkURL, cWorkSign, cWorkPhpbb, aWorkPhpbb, lDebug
MEMVAR BGfont, FGfont, cTranslateCP

*+--------------------------------------------------------------------
*+
*+    Procedure DownloadRange()
*+
*+    Called from ( forumhmg.prg )   3 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DownloadRange()

LOCAL nStart, nEnd, cTitle, nPosi, nLastRec
LOCAL oldFilter := DBFILTER()
LOCAL nCount    := 0
LOCAL nMax
LOCAL nEvery

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
      RETURN
   ENDIF

   IF isWindowDefined( "DlRange" )
      DoMethod( "DlRange", "Button_Download", "SetFocus" )
   ELSE

      lShowOnce := .T.
      lBreak := .F.
      cSID := SPACE( 80 )

      SayBarText(, "ICONONE" )

      SELECT 1
      IF !USED()
         MsgInfo( "need DBF" )
         RETURN
      ENDIF

      SET FILTER TO
      // ORDSETFOCUS( "MSGDATE" )
      // change 13.09.2022
      ORDSETFOCUS( "DUPECHECK" )
      GO BOTTOM
      nLastRec := RECNO()
      nStart := FORUM->TOPICNO

      IF nstart - 50 > 0
         nStart -= 50
      ELSE
         nStart := 1
      ENDIF
      nEnd := nStart + 100

      nPosi := ASCAN( aWorkPhpbb, { | e | e = cWorkPhpbb } )
      cTitle := aWorkPhpbb[ nPosi ]

      DEFINE WINDOW DlRange ;
            AT 0, 0 ;
            WIDTH 324 ;
            HEIGHT 190 ;
            TITLE cTitle ;
            ICON "AUGEOHR" ;
            NOSIZE ;
            NOMAXIMIZE ;
            NOMINIMIZE ;
            TOPMOST ;
            ON INIT SnapToCtrl( "DlRange", "Button_Download" ) ;
            BACKCOLOR BGfont

         DEFINE LABEL Label_1
            ROW 20
            COL 20
            WIDTH 80 + 50
            HEIGHT 24
            VALUE "Range From"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE LABEL Label_2
            ROW 20
            COL 120 + 40
            WIDTH 80 + 50
            HEIGHT 24
            VALUE "Range to"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_1
            ROW 50
            COL 20
            WIDTH 80 + 50
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            NUMERIC .T.
            VALUE nStart
         END TEXTBOX

         DEFINE TEXTBOX Text_2
            ROW 50
            COL 120 + 40
            WIDTH 80 + 50
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            NUMERIC .T.
            VALUE nEnd
         END TEXTBOX

         DEFINE LABEL Label_INFO
            ROW 94
            COL 20
            WIDTH 270
            HEIGHT 46
            VALUE ""
            FONTNAME "Arial"
            FONTSIZE 20
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VISIBLE .F.
         END LABEL

         DEFINE BUTTON Button_Download
            ROW 94
            COL 20
            WIDTH 270
            HEIGHT 46
            ACTION DoDownloadNow( nLastRec )
            CAPTION "&Go"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            PICTURE "MYGO"
            PICTALIGNMENT Right
         END BUTTON

         DEFINE PROGRESSBAR ProgressBar_1
            ROW 144
            COL 4
            WIDTH 310
            HEIGHT 5
            RANGEMIN 1
            RANGEMAX 100
            VALUE 0
            VISIBLE .F.
            BACKCOLOR BGfont
            FORECOLOR FGfont
         END PROGRESSBAR

      END WINDOW

      DlRange.Button_Download.setfocus

      ON KEY ESCAPE OF DlRange ACTION BreakDownload()
      ON KEY F1 OF DlRange ACTION nil
      ON KEY CONTROL + S OF DlRange ACTION InputSID()

      CENTER WINDOW DlRange IN FORUM
      ACTIVATE WINDOW DlRange

      SET FILTER TO &oldFilter

   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure BreakDownload()
*+
*+    Called from ( dlrange.prg )   1 - procedure downloadrange()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE BreakDownload()

   IF lrunning = .F.
      DlRange.Release
   ELSE
      IF msgyesno( "Break Download ?", "Download" ) == .T.
         lBreak := .T.
      ENDIF
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoDownloadNow()
*+
*+    Called from ( dlrange.prg )   1 - procedure downloadrange()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoDownloadNow( nLastRec )

LOCAL nStart     := DlRange.Text_1.Value
LOCAL nEnd       := DlRange.Text_2.Value
LOCAL lWasCreate := .F.

   IF ( nEnd - nStart ) < 100
      MsgInfo( "End must be >= Start + 100" )
      RETURN
   ENDIF

   IF USED()
      IF RECCOUNT() < 2
         lWasCreate := .T.
      ENDIF

      DlRange.Button_Download.Enabled := .F.
      DlRange.Button_Download.VISIBLE := .F.

      DlRange.ProgressBar_1.Value := 0
      DlRange.ProgressBar_1.VISIBLE := .T.
      DlRange.Label_INFO.VISIBLE := .T.

      DoErrorLog( "CLEAR" )
      lrunning := .T.
      StartDownLoad( nStart, nEnd )
      lrunning := .F.
      DoErrorLog( "RESULT" )

      IF isWindowDefined( "DlRange" )
         DlRange.Release
      ENDIF

      DoBrowseRefresh( lWasCreate, nLastRec )                         // in FORUMHMG.PRG
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure IncrementProgressbar()
*+
*+    Called from ( dlrange.prg )   1 - static procedure startdownload()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE IncrementProgressbar()

   DlRange.ProgressBar_1.Value := DlRange.ProgressBar_1.Value + 1
   DO EVENTS
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure SayInfo()
*+
*+    Called from ( dlrange.prg )   1 - static procedure startdownload()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SayInfo( cInfo )

   DlRange.Label_INFO.Value := cInfo
   DO EVENTS
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure StartDownLoad()
*+
*+    Called from ( dlrange.prg )   1 - static procedure dodownloadnow()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE StartDownLoad( nStart, nEnd )

LOCAL cHome      := hb_DirBase()
LOCAL cFile      := ""
LOCAL nCount     := 0                                                 // Profressbar increment
LOCAL nEvery     := 0                                                 // every 1 %
LOCAL nAllItems  := 0                                                 // "posts" of Thread
LOCAL nStartPG   := 1                                                 // Startpage No.
LOCAL nTimeStart, nTimeStop, nTimeCalc
LOCAL cDBF
LOCAL cURL, ii, cText := ""

   //    cFile := GetUniqueFileName( cWorkPath )
   cFile := GetThreadFileName( cWorkPath, YYMMDD() )

   nEvery := INT( ( nEnd - nStart ) / 100 )

   SET DATE ANSI
   SET CENTURY ON

   ORDSETFOCUS( "DUPECHECK" )

   SayBarText( TIME() + " Start Import", "ICOGO" )
   SetNewCursor( "WAIT" )

   nTimeStart := SECONDS()
   FOR ii := nStart TO nEnd

      IF lBreak = .T.
         EXIT
      ENDIF

      cURL := cWorkURL + cWorkSign + LTRIM( STR( ii ) ) + IF( !EMPTY( cSID ), "&sid=" + cSID, "" )
      ondummy( TIME(), "StartDownLoad", cURL )

      nStartPG := 0                                                   // unused

      DO WHILE .T.
         nAllItems := 0

         IF lDebug = .T.
            //  cFile := GetUniqueFileName( cWorkPath )
            cFile := GetThreadFileName( cWorkPath, ii )
         ENDIF
         DownloadFromWWW( cURL, cFile, ii )

         IF lBreak = .T.
            EXIT
         ENDIF

         IF FILE( cFile )
            // here "analyze" HTLM Webpage ...
            // nAllItems : RETURN Value of 'class="pagination"' $ cLine

            nAllItems := StripHTMLCode( cFile, ii, .F. )
         ELSE
            EXIT
         ENDIF

         nStartPG ++
         IF nStartPG * 10 < nAllItems
            cURL := cWorkURL + cWorkSign + LTRIM( STR( ii ) ) + "&start=" + LTRIM( STR( nStartPG * 10 ) ) + IF( !EMPTY( cSID ), "&sid=" + cSID, "" )
            OnDummy( TIME(), "next Page", nStartPG, nAllItems, cURL )
         ELSE
            EXIT
         ENDIF

         DO EVENTS

      ENDDO

      nCount ++
      IF ( ( nCount ) % ( nEvery ) ) == 0
         IncrementProgressbar()
      ENDIF

      IF ( ( nCount ) % ( 10 ) ) == 0
         nTimeCalc := ( SECONDS() - nTimeStart ) / nCount
         cText := "Time left : " + Sec2HMS( ( ( nEnd - nStart ) - nCount ) * nTimeCalc )
         SayInfo( cText )
      ENDIF

   NEXT
   nTimeStop := SECONDS()

   ORDSETFOCUS( "MSGDATE" )
   GO BOTTOM

   SET DATE GERMAN

   ondummy( TIME() + " read " + LTRIM( STR( nEnd - nStart ) ) + " Topic : " + SEC2HMS( nTimeStop - nTimeStart ) )
   SayBarText( TIME() + " read " + LTRIM( STR( nEnd - nStart ) ) + " Topic : " + SEC2HMS( nTimeStop - nTimeStart ), "ICONONE" )
   SetNewCursor()

   IF lDebug = .F.
      FERASE( cFile )
   ENDIF

   DoMethod( "FORUM", "Browse_Main", "SetFocus" )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SnapToCtrl()
*+
*+    Called from ( dlallcod.prg )   1 - procedure downloadrenewcode()
*+                ( dlrange.prg )   1 - procedure downloadrange()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SnapToCtrl( cForm, cControl )

LOCAL hWnd, nRowCtrl, nColCtrl, nHeightCtrl, nWidthCtrl, nColPointer, nRowPointer

   IF !( IsControlDefined( &cControl, &cForm ) )
      RETURN
   ENDIF

   hWnd := GetProperty( cForm, 'Handle' )

   nRowCtrl := GetProperty( cForm, cControl, 'Row' )
   nColCtrl := GetProperty( cForm, cControl, 'Col' )
   nHeightCtrl := GetProperty( cForm, cControl, 'Height' )
   nWidthCtrl := GetProperty( cForm, cControl, 'Width' )

   // Center of control
   nRowPointer := nRowCtrl + ( nHeightCtrl / 2 )
   nColPointer := nColCtrl + ( nWidthCtrl / 2 )

   HMG_SetCursorPos( hWnd, nRowPointer, nColPointer )
   DoMethod( cForm, cControl, "Setfocus" )
RETURN

*+--------------------------------------------------------------------
*+
*+    Function DownloadFromWWW()
*+
*+    Called from ( dlrange.prg )   1 - static procedure startdownload()
*+                ( forumhmg.prg )   1 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
FUNCTION DownloadFromWWW( cURL, cFile, nThreadNo )

LOCAL oError, nTry, nStatus, nReadystate, cText
LOCAL bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
LOCAL oHttp     := Win_OleCreateObject( "MSXML2.ServerXMLHTTP" )

   IF FILE( cFile )
      hb_FileDelete( cFile )
   ENDIF

   IF .NOT. "http" $ cUrl
      oHttp := NIL
      RETURN .F.
   ENDIF

   BEGIN SEQUENCE                                                     // WITH { | oError | BREAK( oError ) }
      oHttp:Open( "GET", cUrl, .F. )
      oHttp:setRequestHeader( "User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0" )

      nTry := 0
      DO WHILE EMPTY( oHTTP:readyState )                              // = 0
         nTry ++
         millisec( 500 )
         DO Events
         IF nTry > 5
            BREAK
         ENDIF
      ENDDO

      oHttp:Send()

      nReadystate := oHttp:readyState
      IF nReadystate <> 4
         BREAK
      ENDIF

      nStatus := oHttp:Status
      IF nStatus = 200
         StrFile( oHttp:ResponseBody(), cFile )
      ELSE
         Ondummy( oHttp:Status )
      ENDIF

   RECOVER USING oError
      ERRORBLOCK( bOldError )

      IF EMPTY( nReadystate )
      ELSE
         lBreak := .T.
         lShowOnce := .T.
      ENDIF
      Ondummy( TIME(), oError:description, oError:operation, HB_VALTOSTR( oError:osCode ), "Error download " + cUrl )

      cText := hb_Translate( oError:Description, cTranslateCP + "WIN" )
      SayBarText( cText, "ICOERROR" )

      IF lBreak = .F.
         cText := "Error Thread No. : " + VAR2CHAR( nThreadNo ) + CRLF + cText
         MessageBoxTimeout( cText, "readyState " + VAR2CHAR( nReadystate ), MB_ICONERROR, 3000 )
         lShowOnce := .F.
      ENDIF

      IF lShowOnce = .T.
         lShowOnce := .F.
         MsgStop( "Error : " + cText, "readyState " + VAR2CHAR( nReadystate ) )
      ENDIF

      AADD( aError, { "Error Thread No. : " + VAR2CHAR( nThreadNo ), RECNO() } )

   END SEQUENCE

   ERRORBLOCK( bOldError )

   oHttp:Abort()
   oHttp := NIL

RETURN FILE( cFile )

*+--------------------------------------------------------------------
*+
*+    Procedure DoErrorLog()
*+
*+    Called from ( dlallcod.prg )   2 - static procedure newfwcode()
*+                ( dlrange.prg )   2 - static procedure dodownloadnow()
*+                ( forumhmg.prg )   1 - procedure main()
*+                                   2 - static procedure testlog()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoErrorLog( cAction, lMessage )

   DO CASE
      CASE EMPTY( cAction )

      CASE cAction = "CLEAR"
         aError := {}

      CASE cAction = "RESULT"
         IF IsWindowDefined( "DlRange" )
            DoMethod( "DlRange", "Release" )
         ENDIF
         IF IsWindowDefined( "DlRenewCode" )
            DoMethod( "DlRenewCode", "Release" )
         ENDIF

         IF !EMPTY( aError )
            ListLog( ACLONE( aError ) )
         ELSE
            //  MessageBoxTimeout( "no Error List", "RESULT", MB_ICONINFORMATION, 4000 )
         ENDIF
         aError := {}

      CASE cAction = "LISTBOX"
         IF !EMPTY( aError )
            ListLog( ACLONE( aError ) )
         ELSE
            //  MsgInfo( "no Error List" )
            MessageBoxTimeout( "no Error List", "RESULT", MB_ICONINFORMATION, 3000 )
         ENDIF

      CASE cAction = "GENERATE"
         aError := {}
         AADD( aError, { "Test1", 1001 } )
         AADD( aError, { "Test2", 2002 } )
         AADD( aError, { "Test3", 3003 } )

   ENDCASE
RETURN

*+--------------------------------------------------------------------
*+
*+    Function GetThreadFileName()
*+
*+    Called from ( dlrange.prg )   2 - static procedure startdownload()
*+                ( forumhmg.prg )   1 - procedure dorenewmsg()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetThreadFileName( cPath, ii )

LOCAL cBuffer := cPath + "\" + "T" + STRZERO( ii, 7 ) + ".HTML"
   IF FILE( cBuffer )
      FERASE( cBuffer )
   ENDIF
RETURN cBuffer

*+--------------------------------------------------------------------
*+
*+    Function YYMMDD()
*+
*+    Called from ( dlrange.prg )   1 - static procedure startdownload()
*+
*+--------------------------------------------------------------------
*+
FUNCTION YYMMDD()

LOCAL cYYMMDD
LOCAL dDate   := DATE()

   cYYMMDD := SUBSTR( LTRIM( STR( YEAR( dDate ) ) ), 3, 2 )
   cYYMMDD += STRZERO( MONTH( dDate ), 2 )
   cYYMMDD += STRZERO( DAY( dDate ), 2 )

RETURN VAL( cYYMMDD )

*+--------------------------------------------------------------------
*+
*+    Procedure InputSID()
*+
*+    Called from ( dlrange.prg )   1 - procedure downloadrange()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE InputSID()

LOCAL cValue := GetInPut( "Input SID", "SID Info", cSID )
   IF !EMPTY( TRIM( cValue ) )
      cSID := TRIM( cValue )
   ENDIF
RETURN

*+ EOF: DLRANGE.PRG
