*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\EDITDBF.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure EDIT_PHPBB()
*+               Procedure EDIT_HTMLSIGN()
*+               Procedure EDIT_USER()
*+               Static Procedure DoPHPinit()
*+               Static Procedure FORUMDIR_STORE()
*+               Static Procedure FORUMDIR_REPLACE()
*+               Static Procedure FORUMDIR_APPEND()
*+               Static Procedure FORUMDIR_DELETE()
*+               Static Procedure DoHTMLinit()
*+               Static Procedure HTMLSIGN_STORE()
*+               Static Procedure HTMLSIGN_REPLACE()
*+               Static Procedure HTMLSIGN_APPEND()
*+               Static Procedure HTMLSIGN_DELETE()
*+               Static Procedure DoNOTUSERinit()
*+               Static Procedure NOTUSER_STORE()
*+               Static Procedure NOTUSER_REPLACE()
*+               Static Procedure NOTUSER_APPEND()
*+               Static Procedure NOTUSER_DELETE()
*+               Static Procedure GetLocalFolder()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

// for all 3 Window
STATIC nWinWidth  := 800
STATIC nWinHeight := 220

MEMVAR _HMG_SYSDATA
MEMVAR cWorkPath, cWorkURL, cWorkPhpbb, aWorkPhpbb, lNotUser
MEMVAR BGeditcolor, BFeditcolor
MEMVAR BGfont, FGfont

*+--------------------------------------------------------------------
*+
*+    Procedure EDIT_PHPBB()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE EDIT_PHPBB( nButtons )

PRIVATE BGeditcolor := { || IF( DELETED(), RED, BGfont ) }
PRIVATE BFeditcolor := { || IF( DELETED(), WHITE, FGfont ) }

   IF isWindowDefined( "EDIT_PHPBB" )
      DoMethod( "EDIT_PHPBB", "Browse_1", "SetFocus" )
   ELSE

      SELECT 99
      // USE FORUMDIR.DBF EXCLUSIVE VIA "DBFCDX"
      IF Net_Use( "FORUMDIR.DBF", .T. )
      ELSE
         MsgInfo( "Error open DBF", "FORUMDIR.DBF" )
         RETURN
      ENDIF

      SET DELETED OFF

      DEFINE WINDOW EDIT_PHPBB ;
            AT 636, 858 ;
            WIDTH nWinWidth ;
            HEIGHT nWinHeight ;
            TITLE "FORUMDIR" ;
            ICON "AUGEOHR" ;
            ON INIT DoPHPinit( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON SIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON MAXIMIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            NOSIZE ;
            NOMAXIMIZE ;
            NOMINIMIZE ;
            TOPMOST ;
            BACKCOLOR BGfont

         DEFINE LABEL Label_001
            ROW 10
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "ForumName"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_FORUMNAME
            ROW 10
            COL 90
            WIDTH 150
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 40
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE TEXTBOX Text_SIGN
            ROW 10
            COL 270
            WIDTH 70
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 10
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE BUTTON Button_PATH
            ROW 40
            COL 10
            WIDTH 80 - 10
            HEIGHT 24
            ACTION GetLocalFolder()
            CAPTION ""
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYFOLDER"
            PICTALIGNMENT LEFT
         END BUTTON

         DEFINE TEXTBOX Text_LOCALPATH
            ROW 40
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 80
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE LABEL Label_003
            ROW 70
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "Forum URL"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_FORUMURL
            ROW 70
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 250
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE BROWSE Browse_1
            ROW 10
            COL 360
            WIDTH 340
            HEIGHT 156
            VALUE 1
            WIDTHS { 100, 200, 200 }
            HEADERS { "Name", "Path", "URL" }
            WORKAREA FORUMDIR
            FIELDS { "FORUMNAME", "LOCALPATH", "FORUMURL" }
            FONTNAME "Arial"
            FONTSIZE 11
            ONCHANGE FORUMDIR_STORE()
            VSCROLLBAR .T.
            DYNAMICBACKCOLOR { BGeditcolor, BGeditcolor, BGeditcolor }
            DYNAMICFORECOLOR { BFeditcolor, BFeditcolor, BFeditcolor }
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END BROWSE

         DEFINE BUTTON Button_New
            ROW 103
            COL 10
            WIDTH 80
            HEIGHT 63
            ACTION FORUMDIR_APPEND()
            CAPTION "&new"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYNEW"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Save
            ROW 103
            COL 120
            WIDTH 110
            HEIGHT 63
            ACTION FORUMDIR_REPLACE()
            CAPTION "&save"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYSAVE"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Del
            ROW 103
            COL 260
            WIDTH 80
            HEIGHT 63
            ACTION FORUMDIR_DELETE()
            CAPTION "&delete"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYDEL"
            PICTALIGNMENT TOP
         END BUTTON

      END WINDOW

      ON KEY ESCAPE OF EDIT_PHPBB ACTION EDIT_PHPBB.Release
      CENTER WINDOW EDIT_PHPBB IN FORUM
      ACTIVATE WINDOW EDIT_PHPBB

      SELECT 99
      CLOSE

      SELECT 1
      SET DELETED ON

      RELEASE BGeditcolor, BFeditcolor

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure EDIT_HTMLSIGN()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE EDIT_HTMLSIGN( nButtons )

PRIVATE BGeditcolor := { || IF( DELETED(), RED, BGfont ) }
PRIVATE BFeditcolor := { || IF( DELETED(), WHITE, FGfont ) }

   IF isWindowDefined( "EDIT_HTMLSIGN" )
      DoMethod( "EDIT_HTMLSIGN", "Browse_1", "SetFocus" )
   ELSE
      SELECT 98
      // USE HTMLSIGN.DBF EXCLUSIVE VIA "DBFCDX"
      IF Net_Use( "HTMLSIGN.DBF", .T. )
      ELSE
         MsgInfo( "Error open DBF", "HTMLSIGN.DBF" )
         RETURN
      ENDIF

      SET DELETED OFF

      DEFINE WINDOW EDIT_HTMLSIGN ;
            AT 519, 816 ;
            WIDTH nWinWidth ;
            HEIGHT nWinHeight ;
            TITLE "HTMLSIGN" ;
            ICON "AUGEOHR" ;
            ON INIT DoHTMLinit( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON SIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON MAXIMIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            NOSIZE ;
            NOMAXIMIZE ;
            NOMINIMIZE ;
            TOPMOST ;
            BACKCOLOR BGfont

         DEFINE LABEL Label_001
            ROW 10
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "HTML Sign"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_HTMLSIGN
            ROW 10
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 80
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE LABEL Label_002
            ROW 40
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "change to"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_CHANGETO
            ROW 40
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 40
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE BROWSE Browse_1
            ROW 10
            COL 360
            WIDTH 340
            HEIGHT 156
            VALUE 1
            WIDTHS { 175, 175 }
            HEADERS { "HTML", "change to" }
            WORKAREA HTMLSIGN
            FIELDS { "HTMLSIGN", "CHANGETO" }
            FONTNAME "Arial"
            FONTSIZE 11
            ONCHANGE HTMLSIGN_STORE()
            VSCROLLBAR .T.
            DYNAMICBACKCOLOR { BGeditcolor, BGeditcolor }
            DYNAMICFORECOLOR { BFeditcolor, BFeditcolor }
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END BROWSE

         DEFINE BUTTON Button_New
            ROW 103
            COL 10
            WIDTH 80
            HEIGHT 63
            ACTION HTMLSIGN_APPEND()
            CAPTION "&new"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYNEW"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Save
            ROW 103
            COL 120
            WIDTH 110
            HEIGHT 63
            ACTION HTMLSIGN_REPLACE()
            CAPTION "&save"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYSAVE"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Del
            ROW 103
            COL 260
            WIDTH 80
            HEIGHT 63
            ACTION HTMLSIGN_DELETE()
            CAPTION "&delete"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYDEL"
            PICTALIGNMENT TOP
         END BUTTON

      END WINDOW

      ON KEY ESCAPE OF EDIT_HTMLSIGN ACTION EDIT_HTMLSIGN.Release
      CENTER WINDOW EDIT_HTMLSIGN IN FORUM
      ACTIVATE WINDOW EDIT_HTMLSIGN

      SELECT 98
      CLOSE

      SELECT 1
      SET DELETED ON
      RELEASE BGeditcolor, BFeditcolor

   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure EDIT_USER()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE EDIT_USER( nButtons )

PRIVATE BGeditcolor := { || IF( DELETED(), RED, BGfont ) }
PRIVATE BFeditcolor := { || IF( DELETED(), WHITE, FGfont ) }

   IF isWindowDefined( "EDIT_USER" )
      DoMethod( "EDIT_USER", "Browse_1", "SetFocus" )
   ELSE

      SELECT 97
      // USE NOTUSER.DBF EXCLUSIVE VIA "DBFCDX"
      IF Net_Use( "NOTUSER.DBF", .T. )
      ELSE
         MsgInfo( "Error open DBF", "NOTUSER.DBF" )
         RETURN
      ENDIF

      SET DELETED OFF

      DEFINE WINDOW EDIT_USER ;
            AT 561, 766 ;
            WIDTH nWinWidth ;
            HEIGHT nWinHeight ;
            TITLE "NOTUSER" ;
            ICON "AUGEOHR" ;
            ON INIT DoNOTUSERinit( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON SIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            ON MAXIMIZE LayoutAdjust( ThisWindow.Name, nWinWidth, nWinHeight ) ;
            NOMINIMIZE ;
            NOSIZE ;
            NOMAXIMIZE ;
            TOPMOST ;
            BACKCOLOR BGfont

         DEFINE LABEL Label_001
            ROW 10
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "PHP Forum"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_PHPFORUM
            ROW 10
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 40
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE LABEL Label_002
            ROW 40
            COL 10
            WIDTH 80
            HEIGHT 24
            VALUE "User Name"
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_USERNAME
            ROW 40
            COL 90
            WIDTH 250
            HEIGHT 24
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            MAXLENGTH 40
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            VALUE ""
         END TEXTBOX

         DEFINE BROWSE Browse_1
            ROW 10
            COL 360
            WIDTH 340
            HEIGHT 156
            VALUE 1
            WIDTHS { 175, 175 }
            HEADERS { "Forum", "User" }
            WORKAREA NOTUSER
            FIELDS { "PHPFORUM", "USERNAME" }
            FONTNAME "Arial"
            FONTSIZE 11
            ONCHANGE NOTUSER_STORE()
            VSCROLLBAR .T.
            DYNAMICBACKCOLOR { BGeditcolor, BGeditcolor }
            DYNAMICFORECOLOR { BFeditcolor, BFeditcolor }
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END BROWSE

         DEFINE BUTTON Button_New
            ROW 103
            COL 10
            WIDTH 80
            HEIGHT 63
            ACTION NOTUSER_APPEND()
            CAPTION "&new"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYNEW"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Save
            ROW 103
            COL 120
            WIDTH 110
            HEIGHT 63
            ACTION NOTUSER_REPLACE()
            CAPTION "&save"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYSAVE"
            PICTALIGNMENT TOP
         END BUTTON

         DEFINE BUTTON Button_Del
            ROW 103
            COL 260
            WIDTH 80
            HEIGHT 63
            ACTION NOTUSER_DELETE()
            CAPTION "&delete"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .T.
            PICTURE "MYDEL"
            PICTALIGNMENT TOP
         END BUTTON

      END WINDOW

      ON KEY ESCAPE OF EDIT_USER ACTION EDIT_USER.Release
      CENTER WINDOW EDIT_USER IN FORUM
      ACTIVATE WINDOW EDIT_USER

      SELECT 97
      CLOSE

      SELECT 1
      SET DELETED ON

      RELEASE BGeditcolor, BFeditcolor

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoPHPinit()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoPHPinit( cForm, nW, nH )

LOCAL nWIDTH  := GetProperty( cForm, "WIDTH" )
LOCAL nHEIGHT := GetProperty( cForm, "HEIGHT" )
LOCAL aZoom   := GetZoomFactor()

   GetLayout( cForm )

   // new Size -> resize Layout
   SetProperty( cForm, "WIDTH", nW * aZoom[ 1 ] * 0.90 )
   SetProperty( cForm, "HEIGHT", nH * aZoom[ 2 ] * 0.90 )
   LayoutAdjust( cForm, nW, nH )

   CENTER WINDOW &cForm

   FORUMDIR_STORE()
   EDIT_PHPBB.Browse_1.SetFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FORUMDIR_STORE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+                                   1 - static procedure dophpinit()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FORUMDIR_STORE()

   EDIT_PHPBB.Text_FORUMNAME.Value := FIELD->FORUMNAME
   EDIT_PHPBB.Text_LOCALPATH.Value := FIELD->LOCALPATH
   EDIT_PHPBB.Text_FORUMURL.Value := FIELD->FORUMURL
   EDIT_PHPBB.Text_SIGN.Value := FIELD->THREADSIGN

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FORUMDIR_REPLACE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FORUMDIR_REPLACE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      REPLACE FIELD->FORUMNAME WITH EDIT_PHPBB.Text_FORUMNAME.Value
      REPLACE FIELD->LOCALPATH WITH EDIT_PHPBB.Text_LOCALPATH.Value
      REPLACE FIELD->FORUMURL WITH EDIT_PHPBB.Text_FORUMURL.Value
      REPLACE FIELD->THREADSIGN WITH EDIT_PHPBB.Text_SIGN.Value
      DBRUNLOCK( nRecord )
      SKIP( 0 )
      EDIT_PHPBB.Browse_1.Refresh
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FORUMDIR_APPEND()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FORUMDIR_APPEND()

   APPEND BLANK
   EDIT_PHPBB.Browse_1.Refresh
   EDIT_PHPBB.Text_FORUMNAME.SetFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure FORUMDIR_DELETE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE FORUMDIR_DELETE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      IF DELETED()
         RECALL
      ELSE
         DELETE
      ENDIF
      DBRUNLOCK( nRecord )
      EDIT_PHPBB.Browse_1.Refresh
      EDIT_PHPBB.Browse_1.SetFocus
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoHTMLinit()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_htmlsign()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoHTMLinit( cForm, nW, nH )

LOCAL nWIDTH  := GetProperty( cForm, "WIDTH" )
LOCAL nHEIGHT := GetProperty( cForm, "HEIGHT" )
LOCAL aZoom   := GetZoomFactor()

   GetLayout( cForm )

   // new Size -> resize Layout
   SetProperty( cForm, "WIDTH", nW * aZoom[ 1 ] * 0.90 )
   SetProperty( cForm, "HEIGHT", nH * aZoom[ 2 ] * 0.90 )
   LayoutAdjust( cForm, nW, nH )

   CENTER WINDOW &cForm

   HTMLSIGN_STORE()
   EDIT_HTMLSIGN.Browse_1.SetFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HTMLSIGN_STORE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_htmlsign()
*+                                   1 - static procedure dohtmlinit()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HTMLSIGN_STORE()

   EDIT_HTMLSIGN.Text_HTMLSIGN.Value := FIELD->HTMLSIGN
   EDIT_HTMLSIGN.Text_CHANGETO.Value := FIELD->CHANGETO
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HTMLSIGN_REPLACE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_htmlsign()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HTMLSIGN_REPLACE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      REPLACE FIELD->HTMLSIGN WITH EDIT_HTMLSIGN.Text_HTMLSIGN.Value
      REPLACE FIELD->CHANGETO WITH EDIT_HTMLSIGN.Text_CHANGETO.Value
      DBRUNLOCK( nRecord )
      SKIP( 0 )
      EDIT_HTMLSIGN.Browse_1.Refresh
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HTMLSIGN_APPEND()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_htmlsign()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HTMLSIGN_APPEND()

   APPEND BLANK
   EDIT_HTMLSIGN.Browse_1.Refresh
   EDIT_HTMLSIGN.Text_HTMLSIGN.setFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure HTMLSIGN_DELETE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_htmlsign()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HTMLSIGN_DELETE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      IF DELETED()
         RECALL
      ELSE
         DELETE
      ENDIF
      DBRUNLOCK( nRecord )
      EDIT_HTMLSIGN.Browse_1.Refresh
      EDIT_HTMLSIGN.Browse_1.setFocus
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoNOTUSERinit()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_user()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoNOTUSERinit( cForm, nW, nH )

LOCAL nWIDTH  := GetProperty( cForm, "WIDTH" )
LOCAL nHEIGHT := GetProperty( cForm, "HEIGHT" )
LOCAL aZoom   := GetZoomFactor()

   GetLayout( cForm )

   // new Size -> resize Layout
   SetProperty( cForm, "WIDTH", nW * aZoom[ 1 ] * 0.90 )
   SetProperty( cForm, "HEIGHT", nH * aZoom[ 2 ] * 0.90 )
   LayoutAdjust( cForm, nW, nH )

   CENTER WINDOW &cForm

   NOTUSER_STORE()
   EDIT_USER.Browse_1.SetFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure NOTUSER_STORE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_user()
*+                                   1 - static procedure donotuserinit()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE NOTUSER_STORE()

   EDIT_USER.Text_PHPFORUM.Value := FIELD->PHPFORUM
   EDIT_USER.Text_USERNAME.Value := FIELD->USERNAME
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure NOTUSER_REPLACE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_user()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE NOTUSER_REPLACE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      REPLACE FIELD->PHPFORUM WITH EDIT_USER.Text_PHPFORUM.Value
      REPLACE FIELD->USERNAME WITH EDIT_USER.Text_USERNAME.Value
      DBRUNLOCK( nRecord )
      SKIP( 0 )
      EDIT_USER.Browse_1.Refresh
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure NOTUSER_APPEND()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_user()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE NOTUSER_APPEND()

   APPEND BLANK
   EDIT_USER.Browse_1.Refresh
   EDIT_USER.Text_PHPFORUM.setFocus
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure NOTUSER_DELETE()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_user()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE NOTUSER_DELETE()

LOCAL nRecord := RECNO()

   IF Net_Lock( nRecord )
      IF DELETED()
         RECALL
      ELSE
         DELETE
      ENDIF
      DBRUNLOCK( nRecord )
      EDIT_USER.Browse_1.Refresh
      EDIT_USER.Browse_1.setFocus
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure GetLocalFolder()
*+
*+    Called from ( editdbf.prg )   1 - procedure edit_phpbb()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE GetLocalFolder()

LOCAL cRet       := ""
LOCAL cTitle     := "local Forum Database Folder"
LOCAL lNewFolder := .T.

STATIC cInitPath := ""

   IF EMPTY( cInitPath )
      cInitPath := cWorkPath
   ENDIF

   cRet := GetFolder( cTitle, TRIM( cInitPath ),, lNewFolder )

   IF !EMPTY( cRet )
      EDIT_PHPBB.Text_LOCALPATH.Value := cRet
   ENDIF
RETURN

*+ EOF: EDITDBF.PRG
