*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\HBINPUT.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Function GetInPut()
*+               Static Function GetInputValue()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"
#include "common.CH"

MEMVAR _HMG_SYSDATA
MEMVAR BGfont, FGfont, cTranslateCP

*+--------------------------------------------------------------------
*+
*+    Function GetInPut()
*+
*+    Called from ( dlrange.prg )   1 - procedure inputsid()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetInPut( cLabel, cTitle, xValue )

LOCAL cRet  := ""
LOCAL cType

   IF VALTYPE( xValue ) = "N"
      cType := "NUMERIC"
   ELSE
      cType := "CHARACTER"
   ENDIF

   IF IsWindowDefined( GetInPut )
      DoMethod( "GetInPut", "Setfocus" )
   ELSE

      DEFINE WINDOW GetInPut ;
            AT 0, 50 ;
            WIDTH 330 ;
            HEIGHT 170 ;
            TITLE cTitle ;
            ICON "AUGEOHR" ;
            NOMAXIMIZE ;
            NOMINIMIZE ;
            TOPMOST ;
            BACKCOLOR BGfont

         DEFINE LABEL Label_1
            ROW 10
            COL 10
            WIDTH 300
            HEIGHT 30
            VALUE cLabel
            FONTNAME "Arial"
            FONTSIZE 11
            VISIBLE .T.
            BACKCOLOR BGfont
            FONTCOLOR FGfont
         END LABEL

         DEFINE TEXTBOX Text_1
            ROW 50
            COL 10
            WIDTH 300
            HEIGHT 30
            FONTNAME "Arial"
            FONTSIZE 11
            ONENTER GetInputValue( @cRet )
            TABSTOP .T.
            VISIBLE .T.
            READONLY .F.
            DISABLEDBACKCOLOR Nil
            DISABLEDFONTCOLOR Nil
            CASECONVERT NONE
            BACKCOLOR nil                                             // SP_nColor5()                                    // {192,192,192}
            FONTCOLOR nil                                             // SP_nColor6()
            INPUTMASK Nil
            FORMAT Nil
            IF VALTYPE( xValue ) = "N"
               DATATYPE NUMERIC
            ELSE
               DATATYPE CHARACTER
            ENDIF
            VALUE xValue
         END TEXTBOX

         DEFINE BUTTON Button_OK
            ROW 90
            COL 10
            WIDTH 100
            HEIGHT 30
            ACTION GetInputValue( @cRet )
            CAPTION "&OK"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            PICTURE "MYOK"
            PICTALIGNMENT LEFT
         END BUTTON

         DEFINE BUTTON Button_Abort
            ROW 90
            COL 210
            WIDTH 100
            HEIGHT 30
            ACTION GetInPut.Release
            CAPTION "&Abort"
            FONTNAME "Arial"
            FONTSIZE 11
            TABSTOP .T.
            VISIBLE .T.
            PICTURE "MYEXIT"
            PICTALIGNMENT LEFT
         END BUTTON

      END WINDOW

      ON KEY ESCAPE OF GetInPut ACTION GetInPut.Release
      CENTER WINDOW GetInPut IN FORUM
      GetInPut.Text_1.setfocus()
      ACTIVATE WINDOW GetInPut
   ENDIF
RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Static Function GetInputValue()
*+
*+    Called from ( hbinput.prg )   2 - function getinput()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetInputValue( cRet )

   cRet := GetInPut.Text_1.Value
   GetInPut.Release
RETURN NIL

//
//
//

*+ EOF: HBINPUT.PRG
