*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\IPINFO.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure IP_Info()
*+               Function ipprivada()
*+               Function ippublica()
*+               Function direcip()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "FILEIO.CH"
#include "hbsocket.ch"

*+--------------------------------------------------------------------
*+
*+    Procedure IP_Info()
*+
*+    Called from ( forumhmg.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE IP_Info( cNewIP )

LOCAL cRun  := "curl "
LOCAL cPara := "ip-api.com "
LOCAL cClip := " | CLIP "
LOCAL cFile := "GetIP.BAT"
LOCAL cMemo, nHandle

   IF !EMPTY( cNewIP )
      cPara += cNewIP
   ENDIF

   nHandle := FCREATE( cFile, FC_NORMAL )
   IF nHandle == - 1
      MsgInfo( "Error create File : " + cFile, STR( FERROR() ) )
      RETURN
   ELSE
      FWRITE( nHandle, cRun + cPara + cClip )
      FCLOSE( nHandle )
   ENDIF

   System.EmptyClipboard
   ShellExecute( 0, "open", cFile,,, SW_HIDE )

   DO WHILE EMPTY( System.Clipboard )
      hb_idleSleep( 0.1 )
   ENDDO
   cMemo := System.Clipboard

   cMemo := STRTRAN( cMemo, CHR( 27 ), "" )
   cMemo := STRTRAN( cMemo, CHR( 91 ), "" )
   cMemo := STRTRAN( cMemo, "39m", "" )
   cMemo := STRTRAN( cMemo, "92m", "" )
   cMemo := STRTRAN( cMemo, "94m", "" )
   cMemo := STRTRAN( cMemo, "95m", "" )
   cMemo := STRTRAN( cMemo, "96m", "" )
   cMemo := STRTRAN( cMemo, "{", "" )
   cMemo := STRTRAN( cMemo, "}", "" )

   cMemo += CRLF
   cMemo += "Local  IP: " + ipprivada()
   cMemo += CRLF

   cMemo += "Public IP: " + ippublica()
   cMemo += CRLF

   // cMemo += GetLocalName()    + CRLF
   // cMemo += GetLocalAddress() + CRLF
   // cMemo += direcip()
   // Msginfo( ALLTRIM( cMemo ) )

   MessageBoxIndirect(, cMemo, "About FORUMHMG", MB_TOPMOST, "AUGEOHR" )
RETURN

*+--------------------------------------------------------------------
*+
*+    Function ipprivada()
*+
*+    Called from ( ipinfo.prg )   1 - procedure ip_info()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ipprivada()

LOCAL cIpPriv := INETGETHOSTS( NETNAME() ) [1]
RETURN ( cIpPriv )

*+--------------------------------------------------------------------
*+
*+    Function ippublica()
*+
*+    Called from ( ipinfo.prg )   1 - procedure ip_info()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ippublica()

LOCAL cIpPublica := 'NIL'
LOCAL oIp                                                             // := WIN_OLECREATEOBJECT( "MSXML2.XMLHTTP" )

   oIp := Win_OleCreateObject( "MSXML2.ServerXMLHTTP" )
   IF HB_ISOBJECT( oIp )
      oIp:OPEN( "GET", "https://api.ipify.org/", .F. )
      oIp:SEND()
      cIpPublica := LEFT( ALLTRIM( oIp:responseText ), 16 )

      oIp:Abort()
      oIp := NIL
   ENDIF
RETURN ( cIpPublica )

// To see physical device addresses bound with active IP interfaces use:
//
// Para ver las direcciones de dispositivos físicos enlazadas con interfaces IP activas, utilice:

*+--------------------------------------------------------------------
*+
*+    Function direcip()
*+
*+--------------------------------------------------------------------
*+
FUNCTION direcip()

LOCAL aIFace, mip_, mmac_, cText := ""
   FOR EACH aIFace IN hb_socketGetIFaces(, .t. )
      mip_ := aIFace[ HB_SOCKET_IFINFO_ADDR ]
      IF TYPE( 'mip_' ) = 'U'
         mip_ := "Undefined"
      ENDIF
      IF TYPE( 'mip_' ) = 'N'
         mip_ := STR( mip_, LEN( mip_ ) )
      ENDIF
      mmac_ := aIFace[ HB_SOCKET_IFINFO_HWADDR ]
      IF TYPE( 'mmac_' ) = 'U'
         mmac_ := "Undefined"
      ENDIF
      IF TYPE( 'mmac_' ) = 'N'
         mmac_ := STR( mmac_, LEN( mmac_ ) )
      ENDIF
      //     msginfo("IP: "+mip_+"   MAC: "+mmac_)
      cText += "IP: " + mip_ + "   MAC: " + mmac_
   NEXT
RETURN cText

*+ EOF: IPINFO.PRG
