*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\LISTLOG.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure ListLog()
*+               Static Procedure DoInitList()
*+               Static Procedure DoGotoTread()
*+               Static Procedure ReReadThread()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

MEMVAR _HMG_SYSDATA
MEMVAR BGcolor, BFcolor, BGfont, FGfont, nTransparent, cTranslateCP

*+--------------------------------------------------------------------
*+
*+    Procedure ListLog()
*+
*+    Called from ( dlrange.prg )   2 - procedure doerrorlog()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE ListLog( aError )

LOCAL nFontSize := GetProperty( "FORUM", "Browse_Main", "FONTSIZE" )
LOCAL nROW      := GetProperty( "FORUM", "ROW" )
LOCAL nCOL      := GetProperty( "FORUM", "COL" )
LOCAL nWIDTH    := GetProperty( "FORUM", "WIDTH" )
LOCAL nHEIGHT   := GetProperty( "FORUM", "HEIGHT" )

   IF isWindowDefined( "ListLog" )
      DoMethod( "ListLog", "List_1", "Setfocus" )
      DO EVENTS
   ELSE
      DEFINE WINDOW ListLog ;
            AT nROW, nCOL + nWIDTH ;
            WIDTH 300 ;
            HEIGHT nHEIGHT ;
            TITLE "Error List" ;
            ICON "AUGEOHR" ;
            ON INIT DoInitList( aError ) ;
            NOSIZE ;
            NOMAXIMIZE ;
            NOMINIMIZE ;
            BACKCOLOR BGfont

         DEFINE LISTBOX List_1
            ROW 10
            COL 10
            WIDTH 269
            HEIGHT nHEIGHT - 123 - 10
            ITEMS { "" }
            VALUE 0
            FONTNAME "Arial"
            FONTSIZE nFontSize
            TOOLTIP ""
            BACKCOLOR BGfont
            FONTCOLOR FGfont
            ONDBLCLICK DoGotoTread( aError )
            TABSTOP .T.
            VISIBLE .F.
         END LISTBOX

         DEFINE BUTTON Button_1
            ROW nHEIGHT - 100
            COL 10
            WIDTH 260
            HEIGHT 50
            ACTION ReReadThread( aError )                             // DoGotoTread( aError )
            CAPTION "&re-Read all listed Thread"
            FONTNAME "Arial"
            FONTSIZE nFontSize
            TABSTOP .T.
            VISIBLE .T.
            TRANSPARENT .F.
            PICTURE Nil
            PICTALIGNMENT TOP
         END BUTTON

      END WINDOW

      ON KEY ESCAPE OF ListLog ACTION ListLog.Release

      ACTIVATE WINDOW ListLog

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoInitList()
*+
*+    Called from ( listlog.prg )   1 - procedure listlog()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoInitList( aError )

LOCA ii, iMax := LEN( aError )

   ListLog.List_1.DeleteAllItems()
   FOR ii := 1 TO iMax
      ListLog.List_1.AddItem( aError[ ii ] [ 1 ] )
   NEXT

   ListLog.List_1.VISIBLE := .T.
   ListLog.List_1.VALUE := 1

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoGotoTread()
*+
*+    Called from ( listlog.prg )   1 - procedure listlog()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoGotoTread( aError )

LOCAL nItem   := GetProperty( "ListLog", "List_1", 'Value' )
LOCAL nRecord

   IF nItem <= LEN( aError )
      nRecord := aError[ nItem ] [ 2 ]
      ORDSETFOCUS( "DUPECHECK" )
      DoBrowseRefresh(, nRecord )                                     // in FORUMHMG.PRG
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure ReReadThread()
*+
*+    Called from ( listlog.prg )   1 - procedure listlog()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE ReReadThread( aError )

LOCAL nOldRec := RECNO()
LOCAL nRecord
LOCAL ii, iMax := LEN( aError )

   FOR ii := iMax TO 1 STEP - 1
      nRecord := aError[ ii ] [ 2 ]
      GOTO( nRecord )
      DoReNewMsg( .T. )

      ADEL( aError, ii )
      ASIZE( aError, LEN( aError ) - 1 )

      ListLog.List_1.DeleteItem( ii )
   NEXT
   ListLog.Release

   DoBrowseRefresh(, nOldRec )                                        // in FORUMHMG.PRG

RETURN

*+ EOF: LISTLOG.PRG
