*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\SETFILTER.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure DoSetFilterTo()
*+               Static Procedure DoSetNewFilter()
*+               Procedure FillNotUser()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

STATIC cKeyword := ""                                                 // remember
STATIC cAuthor  := ""                                                 // remember

MEMVAR _HMG_SYSDATA
MEMVAR cWorkPath, cWorkURL, cWorkPhpbb, aWorkPhpbb
MEMVAR cWorkKeyWord, cWorkAuthor, lNotUser
MEMVAR BGfont, FGfont

*+--------------------------------------------------------------------
*+
*+    Procedure DoSetFilterTo()
*+
*+    Called from ( forumhmg.prg )   5 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoSetFilterTo( nOrder )

LOCAL cTitle, nPosi

   SELECT 1
   IF !USED()
      MsgInfo( "need DBF" )
      RETURN
   ENDIF

   nPosi := ASCAN( aWorkPhpbb, { | e | e = cWorkPhpbb } )
   cTitle := aWorkPhpbb[ nPosi ]

   DEFINE WINDOW FilterFor ;
         AT 0, 0 ;
         WIDTH 324 ;
         HEIGHT 190 ;
         TITLE cTitle ;
         ICON "AUGEOHR" ;
         NOSIZE ;
         NOMAXIMIZE ;
         NOMINIMIZE ;
         TOPMOST ;
         BACKCOLOR BGfont

      DEFINE LABEL Label_1
         ROW 20
         COL 10
         WIDTH 148
         HEIGHT 24
         VALUE "Keyword"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE LABEL Label_2
         ROW 20
         COL 160
         WIDTH 148 - 48
         HEIGHT 24
         VALUE "Author"
         FONTNAME "Arial"
         FONTSIZE 11
         VISIBLE .T.
         BACKCOLOR BGfont
         FONTCOLOR FGfont
      END LABEL

      DEFINE TEXTBOX Text_Keyword
         ROW 50
         COL 10
         WIDTH 148
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE cWorkKeyWord
      END TEXTBOX

      DEFINE TEXTBOX Text_Author
         ROW 50
         COL 160
         WIDTH 148
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         BACKCOLOR BGfont
         FONTCOLOR FGfont
         VALUE cWorkAuthor
      END TEXTBOX

      DEFINE CHECKBOX NotUser
         ROW 80
         COL 160
         WIDTH 120
         HEIGHT 28
         CAPTION "&Not User"
         VALUE lNotUser
         FONTNAME "Arial"
         FONTSIZE 11
         BACKCOLOR nil                                                // BGfont
         FONTCOLOR nil                                                // FGfont
         TABSTOP .F.
         VISIBLE .T.
      END CHECKBOX

      DEFINE BUTTON Button_NewFilter
         ROW 110
         COL 10
         WIDTH 270 + 30
         HEIGHT 46
         ACTION DoSetNewFilter()
         CAPTION "&Go"
         FONTNAME "Arial"
         FONTSIZE 11
         TABSTOP .T.
         VISIBLE .T.
         PICTURE "MYGO"
         PICTALIGNMENT Right
      END BUTTON

   END WINDOW
   DO CASE
      CASE EMPTY( nOrder )
         DoMethod( "FilterFor", "Text_Keyword", "SetFocus" )
      CASE nOrder = 1
         DoMethod( "FilterFor", "Text_Keyword", "SetFocus" )
      CASE nOrder = 2
         DoMethod( "FilterFor", "Text_Author", "SetFocus" )
   ENDCASE

   ON KEY ESCAPE OF FilterFor ACTION FilterFor.Release

   ON KEY F1 OF FilterFor ACTION MsgInfo( "F9 fill not User from DBF" )
   ON KEY F9 OF FilterFor ACTION FillNotUser( cTitle )

   CENTER WINDOW FilterFor IN FORUM
   ACTIVATE WINDOW FilterFor

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoSetNewFilter()
*+
*+    Called from ( setfilter.prg )   1 - procedure dosetfilterto()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoSetNewFilter()

LOCAL nThreadNo
LOCAL nRecord

   cWorkKeyWord := FilterFor.Text_Keyword.Value
   cWorkAuthor := FilterFor.Text_Author.Value
   lNotUser := FilterFor.NotUser.Value

   nThreadNo := VAL( cWorkKeyWord )
   IF nThreadNo > 0
      ORDSETFOCUS( "DUPECHECK" )
      SEEK( STRZERO( nThreadNo, 5 ) )
      IF FOUND()
         cWorkKeyWord := ""
         SetProperty( "FORUM", "SEEK_KEYWORD", "VALUE", cWorkKeyWord )

         nRecord := RECNO()
         DoBrowseRefresh(, nRecord )
      ELSE
         ORDSETFOCUS( "MSGDATE" )
         DoBrowseRefresh()
      ENDIF
   ELSE

      IF !EMPTY( cWorkKeyWord )
         SetProperty( "FORUM", "SEEK_KEYWORD", "VALUE", cWorkKeyWord )
         SetProperty( "FORUM", "SEEK_KEYWORD", "BACKCOLOR", GREEN )
         SetProperty( "FORUM", "SEEK_KEYWORD", "FORECOLOR", BLACK )
      ELSE
         SetProperty( "FORUM", "SEEK_KEYWORD", "VALUE", "no Kewword" )
         SetProperty( "FORUM", "SEEK_KEYWORD", "BACKCOLOR", BGfont )
         SetProperty( "FORUM", "SEEK_KEYWORD", "FORECOLOR", FGfont )
      ENDIF
      IF !EMPTY( cWorkAuthor )
         IF lNotUser
            SetProperty( "FORUM", "SEEK_AUTHOR", "VALUE", cWorkAuthor )
            SetProperty( "FORUM", "SEEK_AUTHOR", "BACKCOLOR", RED )
            SetProperty( "FORUM", "SEEK_AUTHOR", "FORECOLOR", BLACK )
         ELSE
            SetProperty( "FORUM", "SEEK_AUTHOR", "VALUE", cWorkAuthor )
            SetProperty( "FORUM", "SEEK_AUTHOR", "BACKCOLOR", GREEN )
            SetProperty( "FORUM", "SEEK_AUTHOR", "FORECOLOR", BLACK )
         ENDIF
      ELSE
         SetProperty( "FORUM", "SEEK_AUTHOR", "VALUE", "no Author" )
         SetProperty( "FORUM", "SEEK_AUTHOR", "BACKCOLOR", BGfont )
         SetProperty( "FORUM", "SEEK_AUTHOR", "FORECOLOR", FGfont )
      ENDIF

      ChangeFilter()

   ENDIF

   FilterFor.Release

   DoMethod( "FORUM", "Browse_Main", "SetFocus" )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure FillNotUser()
*+
*+    Called from ( setfilter.prg )   1 - procedure dosetfilterto()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE FillNotUser( cTitle )

LOCAL cString := ""

   SELECT 4
   // USE NOTUSER.DBF VIA "DBFCDX"
   IF Net_Use( "NOTUSER.DBF", .F. )

      SET FILTER TO TRIM( LOWER( NOTUSER->PHPFORUM ) ) = TRIM( LOWER( cTitle ) )
      GO TOP
      DO WHILE !EOF()
         cString += TRIM( NOTUSER->USERNAME ) + "|"
         SKIP
      ENDDO
      CLOSE
   ELSE
      MsgInfo( "Error open DBF", "NOTUSER.DBF" )
   ENDIF

   SELECT 1

   FilterFor.Text_Author.Value := cString
   FilterFor.NotUser.Value := .T.

RETURN

*+ EOF: SETFILTER.PRG
