*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\SHOWMEMO.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure SHOWMEMOFORM()
*+               Static Procedure DoResizeMemo()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"

MEMVAR _HMG_SYSDATA
MEMVAR BGfont, FGfont, nTransparent

*+--------------------------------------------------------------------
*+
*+    Procedure SHOWMEMOFORM()
*+
*+    Called from ( forumhmg.prg )   1 - procedure showmemocode()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SHOWMEMOFORM( cMemoRow, cMemoCol, cMemoWidth, cMemoHeight, cFontSize )

LOCAL nFONTSIZE := VAL( cFontSize )
LOCAL nZoom     := 1
LOCAL nIndex    := 0

   IF isWindowDefined( "SHOWMEMO" )

      nFONTSIZE := GetProperty( "SHOWMEMO", "RichEdit_Code", "FONTSIZE" )
      nZoom := GetProperty( "SHOWMEMO", "RichEdit_Code", "ZOOM" )

      SetProperty( "SHOWMEMO", "RichEdit_Code", "Value", TRIM( FORUM->CODE ) )

      SetProperty( "SHOWMEMO", "RichEdit_Code", "ZOOM", nZoom )
      SetProperty( "SHOWMEMO", "RichEdit_Code", "FONTSIZE", nFONTSIZE * nZoom )

      DO EVENTS

      DoMethod( "SHOWMEMO", "RichEdit_Code", "Refresh" )

   ELSE

      DEFINE WINDOW SHOWMEMO AT VAL( cMemoRow ), VAL( cMemoCol ) ;
            WIDTH VAL( cMemoWidth ) ;
            HEIGHT VAL( cMemoHeight ) ;
            TITLE "Show Code" ;
            ICON "AUGEOHR" ;
            ON SIZE DoResizeMemo() ;
            ON MAXIMIZE DoResizeMemo() ;
            BACKCOLOR BGfont

         DEFINE MAIN MENU
            DEFINE POPUP "&Transparency"
               MENUITEM "100 %" ACTION { || nTransparent := 100, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 90 %" ACTION { || nTransparent := 90, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 80 %" ACTION { || nTransparent := 80, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 70 %" ACTION { || nTransparent := 70, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 60 %" ACTION { || nTransparent := 60, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 50 %" ACTION { || nTransparent := 50, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 40 %" ACTION { || nTransparent := 40, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 30 %" ACTION { || nTransparent := 30, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 20 %" ACTION { || nTransparent := 20, SetTransparency( "SHOWMEMO", nTransparent ) }
               MENUITEM " 10 %" ACTION { || nTransparent := 10, SetTransparency( "SHOWMEMO", nTransparent ) }
            END POPUP
         END MENU

         DEFINE CONTEXT MENU OF SHOWMEMO
            MENUITEM "&Copy to Clipboard" IMAGE "MYCLIP" ACTION RTF2Clip( "CODE" )
         END MENU

         DEFINE STATUSBAR FONT "Arial" SIZE 11
            STATUSITEM ""
         END STATUSBAR

         DEFINE RICHEDITBOX RichEdit_Code
            ROW 0
            COL 0
            WIDTH VAL( cMemoWidth ) - 20
            HEIGHT VAL( cMemoHeight ) - 96
            VALUE TRIM( FORUM->CODE )
            FONTNAME "Arial"
            FONTSIZE nFONTSIZE
            TABSTOP .T.
            VISIBLE .T.
            READONLY .T.
            HSCROLL .T.
            BACKCOLOR nil
            ONLINK DoLink( ThisRichEditBox.GetClickLinkText )
         END RICHEDITBOX

      END WINDOW

      CREATE EVENT PROCNAME ShowRowCol("SHOWMEMO","RichEdit_Code") HWND SHOWMEMO.RichEdit_Code.HANDLE STOREINDEX nIndex
      EventProcessAllHookMessage( nIndex, .T. )

      ON KEY ESCAPE OF SHOWMEMO ACTION SHOWMEMO.Release
      ON KEY F1 OF SHOWMEMO ACTION nil

      Activate Window SHOWMEMO

      EventRemove( nIndex )

   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoResizeMemo()
*+
*+    Called from ( showmemo.prg )   2 - procedure showmemoform()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoResizeMemo()

LOCAL nRow       := GetProperty( "SHOWMEMO", "Row" )
LOCAL nCol       := GetProperty( "SHOWMEMO", "Col" )
LOCAL nWidth     := GetProperty( "SHOWMEMO", "Width" )
LOCAL nHeight    := GetProperty( "SHOWMEMO", "Height" )
LOCAL nBorder    := GETBORDERWIDTH()
LOCAL nTitlebar  := GETTITLEHEIGHT()
LOCAL nStatusbar := BT_StatusBarHeight( "SHOWMEMO" )

   SetProperty( "SHOWMEMO", "RichEdit_Code", "Width", nWidth - ( 2 * nBorder ) )
   SetProperty( "SHOWMEMO", "RichEdit_Code", "Height", nHeight - nTitlebar - nBorder - 34 )

RETURN

*+ EOF: SHOWMEMO.PRG