*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\FORUMHMG\TRANSLAT.PRG
*+
*+    Copyright(C) 1983-2022 by Auge & Ohr
*+
*+    Functions: Procedure TranslateMemoFORM()
*+               Static Procedure OnInitTranslate()
*+               Static Procedure DoResizeTranslate()
*+               Procedure TranslateByGoogle()
*+               Procedure ShowRowCol()
*+               Static Function RTF_RowCol()
*+
*+    Reformatted by Click! 2.05.40 on Oct-6-2022 at  3:32 am
*+
*+--------------------------------------------------------------------

#INCLUDE "HMG.CH"
#INCLUDE "common.CH"

#define WM_USER               1024
#define EM_LINEINDEX          187
#define EM_LINEFROMCHAR       201
#define EM_SCROLLCARET        ( WM_USER + 49 )
#define EM_EXLINEFROMCHAR     ( WM_USER + 54 )
#define EM_SETSEL             0x00B1

MEMVAR _HMG_SYSDATA
MEMVAR BGfont, FGfont, nTransparent, cTranslateCP, lTranslate

*+--------------------------------------------------------------------
*+
*+    Procedure TranslateMemoFORM()
*+
*+    Called from ( forumhmg.prg )   2 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE TranslateMemoFORM( cTLrow, cTLcol, cTLWidth, cTLHeight, cFontSize )

LOCAL nFONTSIZE := VAL( cFontSize )
LOCAL nZoom     := 1
LOCAL nIndex    := 0

   IF .NOT. IsInternet()
      SayBarText(, "ICOSTOP" )
      RETURN
   ENDIF

   IF IsControlDefined( "RichEdit_Translate", "TranslateMemo" )
      nFONTSIZE := GetProperty( "TranslateMemo", "RichEdit_Translate", "FONTSIZE" )
      nZoom := GetProperty( "TranslateMemo", "RichEdit_Translate", "ZOOM" )

      TranslateByGoogle( cTranslateCP )

      SetProperty( "TranslateMemo", "RichEdit_Translate", "ZOOM", nZoom )
      SetProperty( "TranslateMemo", "RichEdit_Translate", "FONTSIZE", nFONTSIZE * nZoom )

      DO EVENTS

      DoMethod( "TranslateMemo", "RichEdit_Translate", "Refresh" )

   ELSE

      DEFINE WINDOW TranslateMemo AT VAL( cTLrow ), VAL( cTLcol ) ;
            WIDTH VAL( cTLWidth ) ;
            HEIGHT VAL( cTLHeight ) ;
            TITLE "Translate Body" ;
            ICON "AUGEOHR" ;
            ON INIT OnInitTranslate() ;
            ON SIZE DoResizeTranslate() ;
            ON MAXIMIZE DoResizeTranslate() ;
            ON LOSTFOCUS nil ;                                        // SetTransparency( ThisWindow.Name, nTransparent ) ;
            ON GOTFOCUS nil ;                                         // SetTransparency( ThisWindow.Name, 100 ) ;
            BACKCOLOR BGfont

         DEFINE CONTEXT MENU OF TranslateMemo
            MENUITEM "&Copy to Clipboard" IMAGE "MYCLIP" ACTION RTF2Clip( "TRANSLATE" )
         END MENU

         DEFINE STATUSBAR FONT "Arial" SIZE 11
            STATUSITEM ""
         END STATUSBAR

         DEFINE RICHEDITBOX RichEdit_Translate
            ROW 0
            COL 0
            WIDTH VAL( cTLWidth ) - 20
            HEIGHT VAL( cTLHeight ) - 60
            VALUE ""
            FONTNAME "Arial"
            FONTSIZE nFONTSIZE
            TABSTOP .T.
            VISIBLE .T.
            READONLY .T.
            BACKCOLOR nil
         END RICHEDITBOX

      END WINDOW

      CREATE EVENT PROCNAME ShowRowCol("TranslateMemo","RichEdit_Translate") HWND TranslateMemo.RichEdit_Translate.HANDLE STOREINDEX nIndex
      EventProcessAllHookMessage( nIndex, .T. )

      ON KEY ESCAPE OF TranslateMemo ACTION TranslateMemo.Release
      ON KEY F1 OF TranslateMemo ACTION nil

      Activate Window TranslateMemo

      EventRemove( nIndex )

   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure OnInitTranslate()
*+
*+    Called from ( translat.prg )   1 - procedure translatememoform()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE OnInitTranslate()

   TranslateByGoogle( cTranslateCP )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoResizeTranslate()
*+
*+    Called from ( translat.prg )   2 - procedure translatememoform()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoResizeTranslate()

LOCAL nRow       := GetProperty( "TranslateMemo", "Row" )
LOCAL nCol       := GetProperty( "TranslateMemo", "Col" )
LOCAL nWidth     := GetProperty( "TranslateMemo", "Width" )
LOCAL nHeight    := GetProperty( "TranslateMemo", "Height" )
LOCAL nBorder    := GETBORDERWIDTH()
LOCAL nTitlebar  := GETTITLEHEIGHT()
LOCAL nStatusbar := BT_StatusBarHeight( "TranslateMemo" )

   SetProperty( "TranslateMemo", "RichEdit_Translate", "Width", nWidth - ( 2 * nBorder ) )
   SetProperty( "TranslateMemo", "RichEdit_Translate", "Height", nHeight - nTitlebar - nBorder - 34 )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure TranslateByGoogle()
*+
*+    Called from ( forumhmg.prg )   1 - static procedure forum_store()
*+                ( translat.prg )   1 - procedure translatememoform()
*+                                   1 - static procedure oninittranslate()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE TranslateByGoogle( cTargetLang )

   // LOCAL cTargetLang := "de"
LOCAL cSourceLang := "auto"                                           // default
LOCAL cSampleText
LOCAL cSourceText
LOCAL cGTUrl
LOCAL hResp, nTry, i, nHttpError, cErrorDesc
LOCAL cTranslated := ""
LOCAL cOryginal   := ""
LOCAL cLangDetect := ""
LOCAL oHTTP, oErr, nReadystate, nStatus

   DEFAULT cTargetLang TO "DE"

   BEGIN SEQUENCE WITH { | o | BREAK( o ) }
      oHTTP := Win_OleCreateObject( "MSXML2.ServerXMLHTTP" )
   RECOVER
   END SEQUENCE

   IF EMPTY( oHTTP )
      RETURN
   ENDIF

   cSampleText := TRIM( FORUM->BODY )
   cSourceText := hb_StrToUTF8( cSampleText )

   cGTUrl := "https://translate.googleapis.com/translate_a/single?client=gtx" + ;
             "&sl=" + cSourceLang + ;
             "&tl=" + cTargetLang + ;
             "&dt=t&q=" + tip_URLEncode( cSourceText )

   BEGIN SEQUENCE WITH { | o | BREAK( o ) }

      oHTTP:Open( "POST", cGTUrl, .F. )
      oHTTP:SetRequestHeader( "Content-Type", "application/x-www-form-urlencoded" )
      nTry := 0
      DO WHILE oHTTP:readyState = 0
         nTry ++
         millisec( 500 )
         DO Events
         IF nTry > 5
            BREAK
         ENDIF
      ENDDO

      oHTTP:Send()

      nReadystate := oHttp:readyState
      IF nReadystate <> 4
         BREAK
      ENDIF

      nStatus := oHttp:Status
      IF nStatus = 200
         IF HB_jsonDecode( oHTTP:responseText, @hResp ) > 0
            cLangDetect := hResp[ 3 ]
            FOR i := 1 TO LEN( hResp[ 1 ] )
               cTranslated += hResp[ 1 ] [ i ] [ 1 ]
               cOryginal += hResp[ 1 ] [ i ] [ 2 ]
            NEXT i
         ENDIF
      ELSE
         BREAK
      ENDIF

      // MsgInfo ("To translate: " + cOryginal   + CRLF + CRLF + ;
      //        "Translated:   " + cTranslated + CRLF + CRLF + ;
      //        "Language: "     + cLangDetect )

      SetProperty( "TranslateMemo", "RichEdit_Translate", "Value", TRIM( cTranslated ) )
      DoMethod( "TranslateMemo", "RichEdit_Translate", "Refresh" )

   RECOVER USING oErr

      IF nStatus = 429
         lTranslate := .F.
         MsgStop( 'too many requests in a given amount of time ("rate limiting")' )
      ELSE
         nHttpError := IF( oHttp:readyState > 1, oHTTP:status, IF( oErr == Nil, - 1, oErr:SubCode ) )
         cErrorDesc := IF( oErr == Nil, "None descripion", hb_Translate( oErr:Description, "DEWIN" ) )
         MsgStop( " Error " + cErrorDesc + " ( " + STR( nHttpError ) + " )" )
      ENDIF
   END SEQUENCE

   oHTTP:Abort()
   oHTTP := NIL

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure ShowRowCol()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE ShowRowCol( cForm, cObj )

LOCAL hWnd   := EventHWND()
LOCAL nIndex := GetControlIndexByHandle( hWnd )
LOCAL ch, cText, i, nPos, aPos, nRow := 0, nCol := 0

   IF nIndex > 0 .AND. ( GetControlTypeByIndex( nIndex ) == "EDIT" .OR. ;
              GetControlTypeByIndex( nIndex ) == "RICHEDIT" )

      IF GetControlTypeByIndex( nIndex ) == "EDIT"
         ch := GetProperty( cForm, cObj, "Value" )
         nPos := GetProperty( cForm, cObj, "CaretPos" )
         FOR i := 1 TO nPos
            IF SUBSTR( ch, i, 1 ) == CHR( 13 )
               nRow ++
               nCol := 0
            ELSE
               nCol ++
            ENDIF
         NEXT i
      ELSE
         aPos := RTF_RowCol( cForm, cObj )
         nRow := aPos[ 1 ]
         nCol := aPos[ 2 ]
      ENDIF
      cText := "Row " + hb_NTOS( nRow ) + " / Col " + hb_NTOS( nCol )
      SetProperty( cForm, "StatusBar", "Item", 1, cText )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function RTF_RowCol()
*+
*+    Called from ( translat.prg )   1 - procedure showrowcol()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RTF_RowCol( cForm, cObj )

LOCAL hRtf, nRow, nCol, nSelStart := 1

   hRtf := GetControlHandle( cObj, cForm )
   nSelStart := GetProperty( cForm, cObj, "CaretPos" )
   nRow := SendMessage( hRtf, EM_EXLINEFROMCHAR, 0, nSelStart )
   nCol := nSelStart - SendMessage( hRtf, EM_LINEINDEX, nRow, 0 )

RETURN ( { nRow + 1, nCol } )

*+ EOF: TRANSLAT.PRG